/*
 * adjusttree : Ajust tree structure
 *                     11 Aug. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

#define    DBG         0

extern   int   reppnum();
extern   int   adjustrec();
extern   void  adjustsph();
extern   void  setcode();
extern   void  udcode();

#if DACCESS
extern struct AccData    *daccess();
extern struct AccData    *dac_pleaf();
#if MOVMBR
#else
extern struct AccData    *dac_pnon();
#endif
extern struct AccData    *accd;
extern int    ins_level;
extern int  *ri_flag;
#endif

extern int  *ch_flag;

extern int  irn,root,maxlevel,maxnode;
extern struct  NodeData **noded;
extern struct PathData *path;
extern double  *rootIa;
extern double  *rootIb;

void     adjusttree(int mode){

    int  i,j,m,id,pid,pnum,cur_level;
    int  hilevel;

#if DBG
int flag;
#endif

    hilevel = maxlevel;

    for (cur_level=maxlevel+1 ; cur_level>0 ; cur_level--){
        for (i=0 ; i<path->num[cur_level] ; i++){
            id = path->node[cur_level][i];
            pnum = -1;
            for (j=0 ; j<path->num[cur_level-1] ; j++){
                pid = path->node[cur_level-1][j];
                pnum = reppnum(pid, id);
                if (pnum != -1)
                    break;
	    }
            if (pnum == -1){
               /*
                * unable to find id
                */
                printf("Error in adjusttree pid=%d pnum=%d id=%d\n",pid,pnum,id);
                exit(1);
	    }
            else{
                path->room[cur_level][i] = pnum;
#if DACCESS
                if (cur_level == maxlevel+1){
                    accd->acc[0] = NODED;
                    accd->acc[1] = pid;
                    accd->acc[2] = REAL;
                    accd->acc[3] = pnum;
                    accd = dac_pleaf(accd);
		}
                else{
#if MOVMBR
                    accd->acc[0] = NODED;
                    accd->acc[1] = noded[pid]->cd[pnum].id;
                    accd->acc[2] = VIRTUAL;
                    accd = daccess(accd);
#else
                    accd->acc[0] = NODED2;
                    accd->acc[1] = pid;
                    accd->acc[2] = REAL;
                    accd->acc[3] = pnum;
                    accd = dac_pnon(accd);
#endif
		}
#endif
                if (cur_level <= maxlevel){
                    adjustsph(pid, pnum, id, cur_level-1);
                    m = adjustrec(pid, pnum, id, cur_level-1);
                    if (m != OFF)
                        hilevel = cur_level-1;
#if MOVMBR
                    if (m != OFF || ch_flag[id]==ON)
                        setcode(noded[pid]->cd[pnum].Ia, noded[pid]->cd[pnum].Ib, id, DUMMY, ALL, cur_level);
#endif
#if DACCESS
                    if (cur_level == maxlevel){
                        if (ch_flag[id] == ON){
                            accd->acc[0] = NODED;
                            accd->acc[1] = id;
                            accd->acc[2] = REAL;
                            accd = daccess(accd);
			}
		    }
                    else{
                        accd->acc[0] = NODED;
                        accd->acc[1] = id;
                        accd->acc[2] = REAL;
                        accd = daccess(accd);
                        if (m == CONTRACTION || ch_flag[id]==ON){
#if MOVMBR
                            for (j=0 ; j<noded[id]->num_child ; j++){
                                accd->acc[0] = NODED;
                                accd->acc[1] = noded[id]->cd[j].id;
                                accd->acc[2] = VIRTUAL;
                                accd = daccess(accd);
			    }
#else
                            accd->acc[0] = NODED2;
                            accd->acc[1] = id;
                            accd->acc[2] = REAL;
                            accd = daccess(accd);
#endif
			}
		    }
                    ch_flag[id]=OFF;
#endif
		}
	    }
	}
    }

#if DACCESS
    accd->acc[0] = NODED;
    accd->acc[1] = root;
    accd->acc[2] = REAL;
    accd = daccess(accd);

    if (ins_level < maxlevel - hilevel)
        ins_level = maxlevel - hilevel;
#endif

    if (hilevel == 0){
        m = adjustrec(0, 0, root, -1);
        if (m != OFF)
            hilevel = -1;
    }

#if MOVMBR
    if (hilevel == -1 || ch_flag[root] == ON)
        setcode(rootIa, rootIb, root, DUMMY, ALL, 0);
#endif

#if DACCESS
    if (m == CONTRACTION || ch_flag[root] == ON){
#if MOVMBR
        if (maxlevel != 0){
            for (j=0 ; j<noded[root]->num_child ; j++){
                accd->acc[0] = NODED;
                accd->acc[1] = noded[root]->cd[j].id;
                accd->acc[2] = VIRTUAL;
                accd = daccess(accd);
            }
        }
#else
        accd->acc[0] = NODED2;
        accd->acc[1] = root;
        accd->acc[2] = REAL;
        accd = daccess(accd);
#endif
    }
#endif
    ch_flag[root]=OFF;

   /*
    * update codes
    */
#if FAST
#else
    if (mode == ON)
#if MOVMBR
        udcode();
#else
        udcode(hilevel);
#endif
#endif

   /*
    * initialize the insert path
    */
    for (i=0 ; i<=maxlevel+1 ; i++)
        path->num[i] = 0;
}
