/* Program name --- constr.c
 *       written by Sakurai   1998.3.17
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        <stdlib.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

#define         LOG(a,b)         (log(b)/log(a))
#define         MEM_SIZE        2000

#define         DBG           0
#define         DBG2          1

extern double             *coe_read();
extern void                vdb_read();
extern int                 index_write();
extern unsigned int       *bit_set();
extern void                ins_m();
extern int                 bit_chk();
extern void                scanleaf();
extern void                checkleaf();

int      spnum();
void     setinfo1();
int     *setbufi();
double  *setbuff();
void     error(char *);

int      rest_mem;

int      max_int;
int      bintcnt;
int      bintcnt2;
int    **buf_int;

int      max_double;
int      bdoublecnt;
int      bdoublecnt2;
double **buf_double;

struct  IndexData *indexd;
struct  NodeData **noded;
struct  ObjectData  **objectd;

int     fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel, root;

double *rootIa, *rootIb;
int    *lbsize, nlb;
int     allbit, allbit_c;

unsigned int *node_bit, *obj_bit;
int  *ri_flag;
int  *ch_flag;

struct PathData buf_path[1];
struct PathData *path=buf_path;

struct StackData **stackd;
struct StackData *buf_stack;
struct NetDatac *buf_netc;
int maxst;

struct  NodeData *buf_node;
struct  ChildData *buf_cd;
struct  ObjectData  *buf_obj;

double  *tmp_cent;
int     *leafid;

int cmode=CONSTRUCT;

main(argc,argv)
int	argc;
char	*argv[];
{
    char    datalist[128];
    char    index_file[128];
    char    read_buf[5000];

    FILE    *fp;

    int     con_cnt, i, j, k, p, maxn, num_leaf, num_nleaf;
    int     vp, ne;

#if ENTIRE
    char    root_file[128];
#endif

#if ENTIRE
    if (argc != 6) error(argv[0]);
#else
    if (argc != 5) error(argv[0]);
#endif

    system("/bin/date");

    strcpy(datalist,argv[1]);
    irn = atoi(argv[2]);
    nlb = atoi(argv[3]);
    sprintf(index_file,"%s",argv[4]);
#if ENTIRE
    sprintf(root_file,"%s",argv[5]);
#endif

    vp = PAGESIZE * 8 - irn * 2 * FLOAT_SIZE * 8;
    ne = irn * nlb * 2 + INT_SIZE * 8;
    maxnode = (int)floor((double)vp / (double)ne);
    if (vp % ne == 0)
        maxnode--;

    vp = PAGESIZE * 8 - irn * 2 * FLOAT_SIZE * 8 - INT_SIZE * 8;
    ne = irn * nlb;
    maxnode_l = (int)floor((double)vp / (double)ne);
    if (vp % ne == 0)
        maxnode_l--;

    minnode = (int)((double)(maxnode*MINENT_P)/(double)100 + 0.5);
    minnode_l = (int)((double)(maxnode_l*MINENT_P)/(double)100 + 0.5);

printf("maxnode=%d maxnode_l=%d minnode=%d minnode_l=%d\n",maxnode, maxnode_l, minnode, minnode_l);

    indexd = (struct IndexData *)malloc(sizeof(struct IndexData));

   /*
    * read data objects
    */
    if ( ( fp = fopen ( datalist , "r" ) ) == NULL ){
        printf( "  %s can not open\n" , datalist);
        exit(1);
    }

    i=0;
   /*
    * determine fmax and nmax
    */
    while (fgets(read_buf,5000,fp) != NULL ) i++;
    rewind(fp);
    tnobj=fmax=i;
    num_leaf = spnum(tnobj, minnode_l, minnode, LEAF);
    num_nleaf = spnum(tnobj, minnode_l, minnode, NON_LEAF);
    num_leaf = (int)(num_leaf*1.0);
    num_nleaf = (int)(num_nleaf*1.0);
    nmax = num_leaf + num_nleaf;

#if DBG
printf("cp00 tnobj=%d minnode=%d minnode_l=%d\n",tnobj,minnode,minnode_l);
printf("cp01 num_leaf=%d num_nleaf=%d nmax=%d\n",num_leaf, num_nleaf, nmax);
#endif

    if (maxnode > maxnode_l)
        maxn = maxnode;
    else
        maxn = maxnode_l;

   /*
    * memory allocation (double)
    */
    rest_mem = MEM_SIZE*1000*1000;
    max_double = irn * 2 + num_leaf * (maxnode_l+1) * irn + num_nleaf * (maxnode+1) * 3 * irn + irn * fmax +irn;
   /* stackd */
    maxst = (int)(nmax * 0.05) + 100;
    max_double += maxst * (maxn+1) * 3;

    if (rest_mem - max_double*8 < 0){
        printf("Error: Can't allocate memory max_double=%d\n",max_double);
        exit(1);
    }
    else
        rest_mem -= max_double*8;
    bdoublecnt = bdoublecnt2 = 0;
    buf_double = (double **)malloc(sizeof(double *));
    buf_double[0] = (double *)malloc(sizeof(double) * max_double);
    if (buf_double == NULL || buf_double[0] == NULL){
        printf("Allocation error : buf_double\n");
        exit(1);
    }

   /*
    * memory allocation (int)
    */
   /* ri_flag (RI_WJ mode) */
    k = nmax;
   /* ch_flag */
    k += nmax;
   /* obj_bit */
    k += (int)(fmax / (sizeof(unsigned int)*8)) + 1;
   /* node_bit */
    k += (int)(nmax / (sizeof(unsigned int)*8)) + 1;
   /* loc_bit */
    allbit = ((int)((nlb*irn*2) / (sizeof(unsigned int)*8)) + 1);
    k += allbit * (maxn+1) * nmax;
    allbit_c = ((int)((nlb*irn) / (sizeof(unsigned int)*8)) + 1);
    k += allbit_c * (maxn+1) * nmax;

#if DBG2
    k = k + nmax*2 + fmax;
#endif
   /* lbsize */
    max_int = k + irn;
   /* leafid */
    max_int += nmax;
    if (rest_mem - max_int*4 < 0){
        printf("Error: Can't allocate memory max_int=%d\n",max_int);
        exit(1);
    }
    else
        rest_mem -= max_int*4;
    bintcnt = bintcnt2 = 0;
    buf_int = (int **)malloc(sizeof(int *));
    buf_int[0] = (int *)malloc(sizeof(int) * max_int);
    if (buf_int == NULL || buf_int[0] == NULL){
        printf("Allocation error : buf_int\n");
        exit(1);
    }

   /*
    * set objectd
    */
    objectd = (struct ObjectData **)malloc(sizeof(struct ObjectData *) * (fmax));
    buf_obj = (struct ObjectData *)malloc(sizeof(struct ObjectData)  * (fmax));
    for (i=0 ; i<fmax ; i++){
        objectd[i] = buf_obj + i;
	objectd[i]->obj_code = setbuff(objectd[i]->obj_code, irn);
    }
    p=0;
    while (fgets(read_buf,5000,fp) != NULL ) {
        vdb_read( read_buf, objectd[p]->obj_name, objectd[p]->obj_code, irn);
        p++;
    }
    fclose(fp);

#if DBG
printf("cp1\n");
#endif

   /*
    * set noded
    */
    root = 0;
    tmp_cent = setbuff(tmp_cent, irn);
    for (i=0 ; i<irn ; i++)
        tmp_cent[i] = 0.0;
    noded = (struct NodeData **)malloc(sizeof(struct NodeData *) * nmax);
    buf_node = (struct NodeData *)malloc(sizeof(struct NodeData) * nmax);
    buf_cd = (struct ChildData *)malloc(sizeof(struct ChildData) * nmax * (maxn+1));
    for (i=0 ; i<nmax ; i++) {
        noded[i] = buf_node + i;
        noded[i]->num_child = 0;
        noded[i]->cd = buf_cd + (maxn+1)*i;
    }
    for (i=0 ; i<maxnode_l+1 ; i++){
        noded[root]->cd[i].cent = setbuff(noded[root]->cd[i].cent, irn);
        noded[root]->cd[i].Ia = tmp_cent;
        noded[root]->cd[i].Ib = tmp_cent;
    }
    noded[root]->loc_bit = (unsigned int *)setbufi((int *)noded[root]->loc_bit, allbit*(maxn+1));
    for (j=0 ; j<allbit*(maxn+1) ; j++) noded[root]->loc_bit[j]=0;
    noded[root]->lbit_cent = (unsigned int *)setbufi((int *)noded[root]->lbit_cent, allbit_c*(maxn+1));
    for (j=0 ; j<allbit_c*(maxn+1) ; j++) noded[root]->lbit_cent[j]=0;
    for (i=1 ; i<nmax ; i++){
        noded[i]->loc_bit = noded[root]->loc_bit;
        noded[i]->lbit_cent = noded[root]->lbit_cent;
    }

   /*
    * set lbsize and memory allocation for rootI
    */
    rootIa = setbuff(rootIa, irn*2);
    rootIb = rootIa+irn;
    lbsize = setbufi(lbsize, irn);
    for (i=0 ; i<irn ; i++)
        lbsize[i] = nlb;
#if ENTIRE
    rootIa = coe_read( rootIa , root_file , irn*2 );
#endif

   /*
    * making obj_bit, node_bit
    */
    k = (int)(fmax / (sizeof(unsigned int)*8)) + 1;
    obj_bit = (unsigned int *)setbufi((int *)obj_bit, k);
    for (i=0 ; i<k ; i++) obj_bit[i]=0;
    obj_bit = bit_set(obj_bit, ON, 0, fmax-1);

    k = (int)(nmax / (sizeof(unsigned int)*8)) + 1;
    node_bit = (unsigned int *)setbufi((int *)node_bit, k);
    for (i=0 ; i<k ; i++) node_bit[i]=0;
    node_bit = bit_set(node_bit, ON, root, root);

   /*
    * malloc stackd
    */
    stackd = (struct StackData **)malloc(sizeof(struct StackData *) * maxst);
    buf_stack = (struct StackData *)malloc(sizeof(struct StackData) * maxst);
    buf_netc = (struct NetDatac *)malloc(sizeof(struct NetDatac) * maxst * (maxn+1));
    for (i=0 ; i<maxst ; i++) {
        stackd[i] = buf_stack + i;
        stackd[i]->use = 0;
        stackd[i]->netd = buf_netc + (maxn+1)*i;
        for (j=0 ; j<maxn+1 ; j++){
            stackd[i]->netd[j].cent = setbuff(stackd[i]->netd[j].cent, irn);
            stackd[i]->netd[j].Ia = setbuff(stackd[i]->netd[j].Ia, irn);
            stackd[i]->netd[j].Ib = setbuff(stackd[i]->netd[j].Ib, irn);
        }
    }

   /*
    * initialize insert path
    */
    for (i=0 ; i<BUF_LEVEL ; i++)
        path->num[i] = 0;

   /*
    * making A-tree
    */
    maxlevel = 0;
    tnnode = 1;
    leafid = setbufi(leafid, nmax);
#if DACCESS
    leafid[root] = LEAF;
#endif
   /* RI_WJ mode */
    ri_flag = setbufi(ri_flag, nmax);
    ch_flag = setbufi(ch_flag, nmax);
    setinfo1();
#if DBG2
    tnobj = 1;
#endif
    for (con_cnt=0 ; con_cnt<fmax ; con_cnt++){
#if RI_WJ
        for (i=0 ; i<nmax ; i++)
#else
        for (i=0 ; i<=maxlevel+2 ; i++)
#endif
            ri_flag[i] = NOT_INVOKE;
        for (i=0 ; i<nmax ; i++)
            ch_flag[i] = OFF;

        ins_m(con_cnt, tmp_cent, tmp_cent, objectd[con_cnt]->obj_code, 1, maxlevel);
#if DBG2
        tnobj++;
        for (i=0 ; i<=maxlevel ; i++){
            if (path->num[i] != 0)
                printf("Error in constr level = %d path->num = %d\n",i,path->num[i]);
        }
#endif
    }
    for (i=0 ; i<nmax ; i++)
        if (bit_chk(node_bit, i) == OFF)
            break;
    nmax = tnnode = i;

#if FAST
    tnobj = fmax;
    scanleaf();
#else
#if DBG2
    tnobj = fmax;
    scanleaf();
#endif
#endif

   /*
    * write index data
    */
    setinfo1();

    checkleaf(leafid);

    index_write(indexd,index_file);

    system("/bin/date");
}

int spnum(int obj, int leaf, int non_leaf, int mode){

    int i,total=0,node;

    if (leaf == 1) leaf++;
    if (non_leaf == 1) non_leaf++;
   /* maximum number of node */
    node = (int)(obj / leaf + 1);

    if (mode == LEAF)
        return node;
    else{
        for (i=BUF_LEVEL ; i>=0 ; i--){
            node = (int)(node / non_leaf + 1);
            total += node;
        }
        return total;
    }
}

void setinfo1(){

    indexd->fmax = fmax;
    indexd->nmax = nmax;
    indexd->irn = irn;
    indexd->tnnode = tnnode;
    indexd->tnobj = tnobj;
    indexd->maxnode = maxnode;
    indexd->minnode = minnode;
    indexd->maxnode_l = maxnode_l;
    indexd->minnode_l = minnode_l;
    indexd->maxlevel = maxlevel;
    indexd->root = root;
    indexd->rootIa = rootIa;
    indexd->rootIb = rootIb;
    indexd->lbsize = lbsize;
    indexd->node_bit = node_bit;
    indexd->obj_bit = obj_bit;
    indexd->noded = noded;
    indexd->objectd = objectd;
}

int *setbufi(data, size)
int   *data;
int    size;
{
    int    i;

    if (bintcnt + size > max_int) {
        bintcnt2++;
        bintcnt = 0;
        max_int = (int)(max_int * 1.5);
        if (size > max_int) max_int = size;
        buf_int = (int **)realloc(buf_int,sizeof(int *) * (bintcnt2+1));
        for (i=0 ; i<10 ; i++) {
            buf_int[bintcnt2] = (int *)malloc(sizeof(int) * max_int);
            if (buf_int[bintcnt2] == NULL) {
                printf("Error: Can't allocate memory buf_int[%d]\n",bintcnt2);
                max_int = (int)(max_int * 0.9);
                if ( i > 8 ) exit(1);
            }
            else break;
        }
    }

    data = buf_int[bintcnt2] + bintcnt;
    bintcnt += size;
    return data;
}

double *setbuff(data, size)
double  *data;
int      size;
{
    int    i;

    if (bdoublecnt + size > max_double) {
        bdoublecnt2++;
        bdoublecnt = 0;
        max_double = (int)(max_double * 1.5);
        if (size > max_double) max_double = size;
        buf_double = (double **)realloc(buf_double,sizeof(double *) * (bdoublecnt2+1));
        for (i=0 ; i<10 ; i++) {
            buf_double[bdoublecnt2] = (double *)malloc(sizeof(double) * max_double);
            if (buf_double[bdoublecnt2] == NULL) {
                printf("Error: Can't allocate memory buf_double[%d]\n",bdoublecnt2);
                max_double = (int)(max_double * 0.9);
                if ( i > 8 ){
                    printf("Warning : memory allcation\n");
                    exit(1);
		}
            }
            else break;
        }
    }

    data = buf_double[bdoublecnt2] + bdoublecnt;
    bdoublecnt += size;
    return data;
}

void error(char *toolname){
#if ENTIRE
    fprintf(stderr,"Usage : %s  datasets  dim  code_length  indexfile  dataspace_file\n",toolname);
#else
    fprintf(stderr,"Usage : %s  datasets  dim  code_length  indexfile\n",toolname);
#endif
    exit(1);
}
