/* Program name --- cre_map.c
 *       written by Sakurai   1997.10.23
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        "indexData.h"
#include        "accData.h"

extern struct  IndexData *index_read();
extern void scanleaf();
extern void checkleaf();
extern void pack_page();
extern void udmap();
extern void map_write();

void    error(char *) ;

struct  IndexData *indexd;
struct  NodeData **noded;
struct  ObjectData **objectd;

int     fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel, root;
unsigned int *node_bit, *obj_bit;

double *rootIa, *rootIb;
int    *lbsize,nlb;
int     allbit, allbit_c;

struct AccData *accd;
int *leafid;

int add_nmax=0;

main(argc,argv)
int	argc;
char	*argv[];
{
    char    index_file[128];
    char    map_file[128];

    int    i, j, k, id;

    int    *mapsizeX,mapsizeY,**map;
    int    *buf_int;

    if (argc != 3) error(argv[0]);

    strcpy(index_file,argv[1]);
    strcpy(map_file,argv[2]);

   /*
    * read index file
    */

    indexd = index_read(index_file);

    fmax = indexd->fmax;
    nmax = indexd->nmax;
    irn = indexd->irn;
    tnnode = indexd->tnnode;
    tnobj = indexd->tnobj;
    maxnode = indexd->maxnode;
    minnode = indexd->minnode;
    maxnode_l = indexd->maxnode_l;
    minnode_l = indexd->minnode_l;
    maxlevel = indexd->maxlevel;
    root = indexd->root;
    rootIa = indexd->rootIa;
    rootIb = indexd->rootIb;
    lbsize = indexd->lbsize;
    node_bit = indexd->node_bit;
    obj_bit = indexd->obj_bit;
    noded = indexd->noded;
    objectd = indexd->objectd;

    nlb = lbsize[0];

   /*
    * scan leaf nodes
    */
    scanleaf();
    leafid = (int *)malloc(sizeof(int) * (nmax));
    checkleaf(leafid);

   /*
    * memory allocation
    */
    accd  = (struct AccData *)malloc(sizeof(struct AccData));

    mapsizeY = nmax * 3;

    mapsizeX = (int *)malloc(sizeof(int) * mapsizeY);

    pack_page(accd);
    if (accd->vol_r_non > accd->vol_r_leaf) j = D_NODED + accd->vol_r_non;
    else j = D_NODED + accd->vol_r_leaf;

    buf_int = (int *)malloc(sizeof(int) * (mapsizeY*j));

    map = (int **)malloc(sizeof(int *) * mapsizeY);
    k = 0;
    for (i=0 ; i<mapsizeY ; i++){
        map[i] = buf_int + k;
        k += j;
    }

    accd->mapsizeX = mapsizeX;
    accd->mapsizeY = mapsizeY;
    accd->map = map;

    udmap();
    map_write(accd, map_file);

    free(indexd);
    free(noded);
    free(objectd);
}

void error(char *toolname){
    fprintf(stderr,"Usage : %s  indexfile mapfile\n",toolname);
    exit(1);
}
