/* Program name --- dac_pleaf.c
 * 
 * for measuring the number of disk accesses relative to leaf nodes
 * 
 *       written by Sakurai   1999.9.2
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        "indexData.h"
#include        "accData.h"

#define         DBG           0

extern int irn;

struct  AccData *dac_pleaf(accd)
struct  AccData *accd;
{
    int   *page,*mapsizeX,mapsizeY,**map,*acc;

    int    i, j, k, line, numwords, flag;
    int    column[MAX]={D_ADD,D_NODED,D_OBJECTD,D_NODED};

    int    room, ent_size, lower_side, upper_side, m1, m2;

    page = accd->page;
    mapsizeX = accd->mapsizeX;
    mapsizeY = accd->mapsizeY;
    map = accd->map;
    acc = accd->acc;

    k=acc[0];
    numwords = column[k];
    for (i=0 ; i<mapsizeY ; i++){
        flag = OK;
        for (j=0 ; j<numwords ; j++){
            if (acc[j] != map[i][j]){
                flag = NG;
                break;
            }
        }
        if (flag == OK) break;
    }
    line = i;

    if (flag == NG){
        printf("dac_pleaf : Data not found no.%d %d %d\n",acc[0],acc[1],acc[2]);
    }

    room = acc[numwords];
    ent_size = FLOAT_SIZE * irn + INT_SIZE + NAME_SIZE;
#if MOVMBR
    lower_side = ent_size * room;
#else
    lower_side = ent_size * room + INT_SIZE;
#endif
    upper_side = lower_side + ent_size;

    m1 = (int)floor(lower_side / (double)PAGESIZE) + numwords;
    m2 = (int)ceil(upper_side / (double)PAGESIZE) + numwords;
    if (m2 > mapsizeX[line])
        m2 = mapsizeX[line];

    for (i=m1 ; i<m2 ; i++){
        k = map[line][i];
        page[k] = ON;
    }

    return accd;
}
