/* Program name --- daccess.c
 *
 * for measuring the number of disk accesses
 *
 *       written by Sakurai   1997.11.19
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        "accData.h"

#define         OK           (1)
#define         NG           (0)
#define         ON           (1)
#define         OFF          (0)

#define         DBG           0

struct  AccData *daccess(accd)
struct  AccData *accd;
{
    int   *page,*mapsizeX,mapsizeY,**map,*acc;

    int    i, j, k, line, numwords, flag;
    int     column[MAX]={D_ADD,D_NODED,D_OBJECTD,D_NODED};

    page = accd->page;
    mapsizeX = accd->mapsizeX;
    mapsizeY = accd->mapsizeY;
    map = accd->map;
    acc = accd->acc;

    k=acc[0];
    numwords = column[k];
    for (i=0 ; i<mapsizeY ; i++){
        flag = OK;
        for (j=0 ; j<numwords ; j++){
            if (acc[j] != map[i][j]){
                flag = NG;
                break;
            }
        }
        if (flag == OK) break;
    }
    line = i;

    if (flag == NG){
        printf("daccess : Data not found no.%d %d %d\n",acc[0],acc[1],acc[2]);
    }
    for (i=numwords ; i<mapsizeX[line] ; i++){
        k = map[line][i];
        page[k] = ON;
    }

    return accd;
}
