/*
 * getlb_v
 *                     29 Jun. 99   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        <math.h>
#include        "indexData.h"
#include        "brpData.h"

#define         LOG(a,b)         (log(b)/log(a))

#define    DBG         0
#define    DBG2        0

extern int  irn, nlb;
extern void calccode();

extern int allbit, allbit_c, maxnode;

#if VLC
void  getlb_v(lbits, pcodea, pcodeb, ccodea, ccodeb, bitnum, mode, lengc)
#else
void  getlb_v(lbits, pcodea, pcodeb, ccodea, ccodeb, bitnum, mode)
#endif
unsigned int *lbits;
double  *pcodea;
double  *pcodeb;
double  *ccodea;
double  *ccodeb;
int      bitnum;
int      mode;
#if VLC
int     *lengc;
#endif
{
    int i,j,lbd=0;
    int devide[BUF_IRN];
    double va[BUF_IRN],vb[BUF_IRN],vc[BUF_IRN];
    double interval[BUF_IRN], tmp;
#if VLC
#else
    int lengc[BUF_IRN];
#endif

#if VLC
    for (i=0 ; i<irn ; i++){
        devide[i] = (int)pow(2, lengc[i]);
    }
#else
    tmp = pow(2, nlb);
    for (i=0 ; i<irn ; i++){
        lengc[i] = nlb;
        devide[i] = (int)tmp;
    }
#endif

    for (i=0 ; i<irn ; i++)
        interval[i] = pcodeb[i] - pcodea[i];

    if (mode == RECT){
       /*
        * calculate ccodea
        */
        for (i=0 ; i<irn ; i++){
            if (ccodea[i] >= pcodeb[i])
                va[i] = devide[i] - 1;
            else
                va[i] = floor((ccodea[i] - pcodea[i]) * devide[i] / interval[i]);
        }
       /*
        * calculate ccodeb
        */
        for (i=0 ; i<irn ; i++){
            if (ccodeb[i] == pcodea[i])
                vb[i] = 0;
            else
                vb[i] = ceil((ccodeb[i] - pcodea[i]) * devide[i] / interval[i]) - 1;
        }

       /*
        * calculate codes
        */
        lbd = bitnum;
        for (i=0 ; i<irn ; i++){
            calccode(lbits, va[i], lbd, lengc[i]);
            lbd += lengc[i];
            calccode(lbits, vb[i], lbd, lengc[i]);
            lbd += lengc[i];
        }
    }

    if (mode == POINT){
       /*
        * calculate ccodec
        */
        for (i=0 ; i<irn ; i++){
            if (ccodea[i] >= pcodeb[i])
                vc[i] = devide[i] - 1;
            else
                vc[i] = floor((ccodea[i] - pcodea[i]) * devide[i] / interval[i]);
        }
       /*
        * calculate codes
        */
        lbd = bitnum;
        for (i=0 ; i<irn ; i++){
            calccode(lbits, vc[i], lbd, lengc[i]);
            lbd += lengc[i];
        }
    }
}
