/*
 * getvarea_v
 *                     1 Dec. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        <math.h>
#include        "indexData.h"
#include        "brpData.h"

#define         DBG       0
#define         DBG2      0

extern int bit_trans();
extern int irn, nlb;

extern int allbit, allbit_c, maxnode;

#if VLC
void getvarea_v(ccodea, ccodeb, pcodea, pcodeb, lbits, bitnum, mode, lengc)
#else
void getvarea_v(ccodea, ccodeb, pcodea, pcodeb, lbits, bitnum, mode)
#endif
double *ccodea;
double *ccodeb;
double *pcodea;
double *pcodeb;
int     bitnum;
unsigned int *lbits;
int     mode;
#if VLC
int     *lengc;
#endif
{
    int i,j,lbd=0;
    double va[BUF_IRN],vb[BUF_IRN],vc[BUF_IRN];
    double interval[BUF_IRN], devide[BUF_IRN], tmp;

#if VLC
#else
    int lengc[BUF_IRN];
#endif

#if VLC
    for (i=0 ; i<irn ; i++){
        devide[i] = pow(2, lengc[i]);
    }
#else
    tmp = pow(2, nlb);
    for (i=0 ; i<irn ; i++){
        lengc[i] = nlb;
        devide[i] = tmp;
    }
#endif

    for (i=0 ; i<irn ; i++)
        interval[i] = pcodeb[i] - pcodea[i];

    if (mode == RECT){
        lbd = bitnum;
        for (i=0 ; i<irn ; i++){
           /*
            * calculate lower value
            */
            va[i] = (double)bit_trans(lbits, lbd, lengc[i]);
            lbd += lengc[i];
           /*
            * calculate upper value
            */
            vb[i] = (double)bit_trans(lbits, lbd, lengc[i]);
            lbd += lengc[i];
        }

#if DBG2
for (i=0 ; i<irn ; i++)
  printf("getvarea_v cp1 : va=%d vb=%d\n",va[i],vb[i]);
#endif
        for (i=0 ; i<irn ; i++){
            ccodea[i] = pcodea[i] + (interval[i] * va[i]) / devide[i];
            ccodeb[i] = pcodea[i] + (interval[i] * (vb[i]+1)) / devide[i];
	}
    }

    if (mode == POINT){
        lbd = bitnum;
        for (i=0 ; i<irn ; i++){
            vc[i] = (double)bit_trans(lbits, lbd, lengc[i]);
            lbd += lengc[i];
        }
#if DBG2
for (i=0 ; i<irn ; i++)
  printf("getvarea_v cp2 : vc=%f\n",vc[i]);
#endif
        for (i=0 ; i<irn ; i++){
            ccodea[i] = pcodea[i] + (interval[i] * vc[i]) / devide[i];
            ccodeb[i] = pcodea[i] + (interval[i] * (vc[i]+1)) / devide[i];
        }
    }

#if DBG
for (i=0 ; i<irn ; i++){
  if (mode == RECT){
    if (ccodea[i] < pcodea[i])
      printf("Error 1-0(getvarea_v) ca=%f pa=%f\n",ccodea[i],pcodea[i]);
    if (ccodeb[i] < pcodea[i])
      printf("Error 1-1(getvarea_v) cb=%f pa=%f\n",ccodeb[i],pcodea[i]);
    if (va[i] >= devide[i] || va[i] < 0)
      printf("Error 1-2(getvarea_v) code a=%f ca=%f\n",va[i],ccodea[i]);
    if (vb[i] >= devide[i] || vb[i] < 0)
      printf("Error 1-3(getvarea_v) code b=%f cb=%f\n",vb[i],ccodeb[i]);

    if (ccodea[i] > pcodeb[i])
      printf("Error 2-0 : getvarea_v dim=%d ccodea=%f pcodeb=%f\n",i,ccodea[i],pcodeb[i]);
    if (ccodeb[i] > pcodeb[i]+0.00001)
      printf("Error 2-1 : getvarea_v dim=%d ccodeb=%f pcodeb=%f\n",i,ccodeb[i],pcodeb[i]);
  }
  if (mode == POINT){
      if (vc[i] >= devide[i] || vc[i] < 0)
        printf("Error 1-4(getvarea_v) code c=%f ca=%f\n",vc[i],ccodea[i]);

    if (ccodea[i] < pcodea[i])
      printf("Error 2-0 : getvarea_v dim=%d ccodea=%f pcodea=%f\n",i,ccodea[i],pcodea[i]);
    if (ccodeb[i] < pcodea[i])
      printf("Error 2-0 : getvarea_v dim=%d ccodeb=%f pcodea=%f\n",i,ccodeb[i],pcodea[i]);
    if (ccodea[i] > pcodeb[i]+0.00001)
      printf("Error 2-1 : getvarea_v dim=%d ccodea=%f pcodeb=%f\n",i,ccodea[i],pcodeb[i]);
    if (ccodeb[i] > pcodeb[i]+0.00001)
      printf("Error 2-1 : getvarea_v dim=%d ccodeb=%f pcodeb=%f\n",i,ccodeb[i],pcodeb[i]);

  }
}
#endif
}
