#define         OK               1
#define         NG               0
#define         YES              1
#define         NO               0
#define         ON               1
#define         OFF              0
#define         NOT_INVOKE       0
#define         INVOKE           1
#define         LOW             (0)
#define         HIGH            (1)
#define         MINDIST         (0)
#define         MINMAX          (1)
#define         MAXDIST         (2)
#define         DOWN            (0)
#define         UP              (1)
#define         NON_LEAF        (0)
#define         LEAF            (1)
#define         RECT            (0)
#define         POINT           (1)
#define         RECTPOINT       (2)
#define         APP             (0)
#define         EXA             (1)
#define         INSERT          (0)
#define         CONSTRUCT       (1)
#define         INDIV           (0)
#define         ALL             (1)
#define         DUMMY            0
#define         EXTENSION       (1)
#define         CONTRACTION     (2)

#define         BUF_LEVEL      30
#define         BUF_IRN       128
#define         BUF_NODE     4092
#define         BUF_NLB        24

/* threshold using reinsert module */
#define         MINENT_P        40
#define         RI_WJ            1
#define         REINS_P         30

#define         ENTIRE           0
#define         MOVMBR           1

#define         CLOCKS_PER_SEC      1000000

struct  IndexData {
                int     maxnode;     /* maximum number of entries in non-leaf node */
                int     minnode;     /* minimum number of entries in non-leaf node */
                int     maxnode_l;   /* maximum number of entries in leaf node */
                int     minnode_l;   /* minimum number of entries in leaf node */
                int     irn;         /* number of dimension */
                int     fmax;        /* maximum number of objects */
                int     nmax;        /* maximum number of nodes */
                int     tnobj;       /* number of objects */
                int     tnnode;      /* number of nodes */
                int     maxlevel;    /* maximum number of level */
                int     root;        /* id number of root node */
                double *rootIa;      /* position of root node (BRP mode) */
                double *rootIb;      /* position of root node (BRP mode) */
                int    *lbsize;      /* size of location bit (BRP mode) */
                unsigned int *node_bit; /* to inspect non-leaf node data */
                unsigned int *obj_bit;  /* to inspect object data */
                struct  NodeData **noded; /* node data */
                struct  ObjectData  **objectd; /* object data */
       };

struct	NodeData {
                int      num_child;
                struct ChildData *cd;
                unsigned int *loc_bit;
                unsigned int *lbit_cent;
	};

struct  ChildData {
                int      id;
                double  *Ia;  
                double  *Ib;
                int      omega;
                double   radius;
                double  *cent;
        };

struct	ObjectData {
                char     obj_name[20];
		double	*obj_code;
	};

struct	SortData {
                int      num;
                struct  NetData *netd;
	};

struct	NetData {
                int      id;
                double   distance;
	};

struct	SortData2 {
                int      num;
                struct  NetData2 *netd;
	};

struct	NetData2 {
                int     id;
                int     room;
                int     level;        /* HJSA mode */
                double  distance1;
                double  distance2;
                int     pid;          /* MOVMBR mode */
                int     pnum;         /* MOVMBR mode */
                double  Ia[BUF_IRN];  /* non-MOVMBR mode */
                double  Ib[BUF_IRN];  /* non-MOVMBR mode */
	};

struct	StackData {
                int      use;
                int      num;
                int      num2;
                struct  NetDatac *netd;
	};

struct	NetDatac {
                int      id;
                double   distance;
                double   *Ia;
                double   *Ib;
                int      omega;
                double   radius;
                double   *cent;
	};

struct  PathData {
                int      node[BUF_LEVEL][BUF_NODE];
                int      room[BUF_LEVEL][BUF_NODE];
                int      num[BUF_LEVEL];
	      };

struct  VisitData {
                int      num;
                struct RoomData *rd;
	      };

struct  RoomData {
                int      level;
                int     *pid;
                int     *pnum;
        };

struct  AreaData {
                double Ia[BUF_IRN];
                double Ib[BUF_IRN];
        };
