#include	<stdio.h>
#include        <stdlib.h>
#include	"indexData.h"

extern void                checkleaf();

extern struct  IndexData *indexd;
extern struct  NodeData **noded;
extern struct  ObjectData **objectd;

extern int     fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel, root;

extern double  *rootIa;
extern double  *rootIb;
extern int     *lbsize,nlb;
extern int  allbit, allbit_c;

extern unsigned int *node_bit, *obj_bit;

extern int add_nmax;

double  buf_rootI[BUF_IRN*2];

struct  IndexData *index_read(filename)
char	*filename;
{

    FILE   *fp;
    int     i, j, k, p, m, m1, m2, maxn, n;
    int     num_leaf, num_nonleaf;
    int     *leafid;

    struct  NodeData *buf_node;
    struct  ChildData *buf_cd;
    struct  ObjectData *buf_obj;
    unsigned int  *buf_bit;
    double  *buf_double;
    int     *buf_int,cnt_int=0,cnt_double=0,cnt_bit=0;
    char     buf_char[50];

    fp = fopen(filename,"rb");
    if (fp == NULL){
        fprintf(stderr,"index_read() error! %s\n", filename);
        return (struct IndexData *)NULL;
    }

   /* line 1 */
    fscanf(fp,"%d %d %d %d %d %d %d %d %d %d %d ",&fmax,&nmax,&irn,&tnobj,&tnnode,&maxnode,&minnode,&maxnode_l,&minnode_l,&maxlevel,&root);
    fscanf(fp,"\n");

    /* malloc buf_int */
    buf_int = (int *)malloc(sizeof(int) * (irn + nmax));
    if (buf_int == NULL){
        printf("Allocation error : buf_int\n");
        exit(1);
    }

   /* malloc buf_double */
    if (maxnode > maxnode_l)
        maxn = maxnode;
    else
        maxn = maxnode_l;

    rootIa = buf_rootI;
    n=fread(rootIa, sizeof(double), irn, fp);

    rootIb = buf_rootI + irn;
    n=fread(rootIb, sizeof(double), irn, fp);

    lbsize = buf_int + cnt_int;
    cnt_int += irn;
    n=fread(lbsize, sizeof(int), irn, fp);
    nlb = lbsize[0];

   /*
    * malloc buf_bit
    */
    noded = (struct NodeData **)malloc(sizeof(struct NodeData *) * (nmax+add_nmax));
    buf_node = (struct NodeData *)malloc(sizeof(struct NodeData) * (nmax+add_nmax));
    buf_cd = (struct ChildData *)malloc(sizeof(struct ChildData) * (nmax+add_nmax) * (maxn+1));
    if (noded == NULL || buf_node == NULL || buf_cd == NULL){
        printf("Allocation error : buf_node\n");
        exit(1);
    }

    k = 0;
    for (i=0 ; i<nmax+add_nmax ; i++){
        noded[i] = buf_node + i;
        noded[i]->cd = buf_cd + k;
        k += maxn + 1;
    }

   /* malloc buf_bit */
    m = (int)(nmax / (sizeof(unsigned int)*8)) + 1;
    m1 = (int)(fmax / (sizeof(unsigned int)*8)) + 1;
    allbit = ((int)(nlb*irn*2 / (sizeof(unsigned int)*8)) + 1);
    allbit_c = ((int)(nlb*irn / (sizeof(unsigned int)*8)) + 1);
    m2 = (allbit+allbit_c) * (maxn+1) * (nmax+add_nmax);
    buf_bit = (unsigned int *)malloc(sizeof(unsigned int) * (m+m1+m2));

    if (buf_bit == NULL){
        printf("Allocation error : buf_bit\n");
        exit(1);
    }
    node_bit = buf_bit + cnt_bit;
    cnt_bit += m;
    obj_bit = buf_bit + cnt_bit;
    cnt_bit += m1;

   /* line 2 node_bit */
    n=fread(node_bit, sizeof(int), m, fp);

   /* line 3 obj_bit */
    n=fread(obj_bit, sizeof(int), m1, fp);

   /*
    * read node data
    */

   /* line 4 num_child */
    for ( i = 0; i < nmax ; i++)
        n=fread(&(noded[i]->num_child), sizeof(int), 1, fp);

   /* line 5 child-id */
    for ( i=0 ; i<nmax ; i++)
        for ( j = 0; j < noded[i]->num_child; j++)
            n=fread(&(noded[i]->cd[j].id), sizeof(int), 1, fp);

    leafid = buf_int + cnt_int;
    cnt_int += nmax;
    checkleaf(leafid);

    num_leaf=0;
    for (i=0 ; i<nmax ; i++)
        if (leafid[i] == ON)
            num_leaf++;
    num_nonleaf = nmax - num_leaf;

    buf_double = (double *)malloc(sizeof(double) * (
        num_nonleaf * (maxnode+1) * irn * 3 
        + num_leaf * (maxnode_l+1) * irn
        + add_nmax * (maxn + 1) * irn * 3));
    if (buf_double == NULL){
        printf("Allocation error : buf_double\n");
        exit(1);
    }

   /* line 6 cent, Ia and Ib */
    for (i=0 ; i<nmax ; i++) {
        if (leafid[i] != ON){
            for (j=0 ; j<maxnode + 1 ; j++){
                noded[i]->cd[j].Ia = buf_double + cnt_double;
                cnt_double += irn;
                noded[i]->cd[j].Ib = buf_double + cnt_double;
                cnt_double += irn;
                noded[i]->cd[j].cent = buf_double + cnt_double;
                cnt_double += irn;
            }
	}
        else{
            for (j=0 ; j<maxnode_l + 1 ; j++){
                noded[i]->cd[j].cent = buf_double + cnt_double;
                cnt_double += irn;
                noded[i]->cd[j].Ia = noded[i]->cd[j].cent;
                noded[i]->cd[j].Ib = noded[i]->cd[j].cent;
            }
	}
    }
    for (i=nmax ; i<nmax+add_nmax ; i++) {
        for (j=0 ; j<maxn + 1 ; j++){
            noded[i]->cd[j].Ia = buf_double + cnt_double;
            cnt_double += irn;
            noded[i]->cd[j].Ib = buf_double + cnt_double;
            cnt_double += irn;
            noded[i]->cd[j].cent = buf_double + cnt_double;
            cnt_double += irn;
	}
    }

    for ( i=0 ; i<nmax ; i++){
        for ( j = 0; j < noded[i]->num_child; j++)
            n=fread(noded[i]->cd[j].cent, sizeof(double), irn, fp);
        if (leafid[i] != ON){
            for ( j = 0; j < noded[i]->num_child; j++)
                n=fread(noded[i]->cd[j].Ia, sizeof(double), irn, fp);
            for ( j = 0; j < noded[i]->num_child; j++)
                n=fread(noded[i]->cd[j].Ib, sizeof(double), irn, fp);
        }
    }

   /* line 9 omega */
    for ( i=0 ; i<nmax ; i++)
        for ( j = 0; j < noded[i]->num_child; j++)
            n=fread(&(noded[i]->cd[j].omega), sizeof(int), 1, fp);

    for (i=0 ; i<nmax+add_nmax ; i++) {
        noded[i]->loc_bit = buf_bit + cnt_bit;
        cnt_bit += allbit*(maxn+1);
        noded[i]->lbit_cent = buf_bit + cnt_bit;
        cnt_bit += allbit_c*(maxn+1);
    }

   /* line 11 loc_bit */
    for ( i=0 ; i<nmax ; i++)
        n=fread(noded[i]->loc_bit, sizeof(int), allbit*maxn, fp);

   /* line 12 loc_bit */
    for ( i=0 ; i<nmax ; i++)
        n=fread(noded[i]->lbit_cent, sizeof(int), allbit_c*maxn, fp);

   /*
    * read data objects
    */
    objectd = (struct ObjectData **)malloc(sizeof(struct ObjectData *) * (fmax));
    buf_obj = (struct ObjectData *)malloc(sizeof(struct ObjectData)  * (fmax));
    if (objectd == NULL || buf_obj == NULL){
        printf("Allocation error : buf_obj\n");
        exit(1);
    }

    for (i=0 ; i<fmax ; i++)
        objectd[i] = buf_obj + i;

   /* line 13 obj_name */
    for ( i = 0; i < fmax; i++)
        n=fread(objectd[i]->obj_name, 1, 20, fp);

    indexd = (struct IndexData *)malloc(sizeof(struct IndexData));
    indexd->fmax = fmax;
    indexd->nmax = nmax;
    indexd->irn = irn;
    indexd->tnnode = tnnode;
    indexd->tnobj = tnobj;
    indexd->maxnode = maxnode;
    indexd->minnode = minnode;
    indexd->maxnode_l = maxnode_l;
    indexd->minnode_l = minnode_l;
    indexd->maxlevel = maxlevel;
    indexd->root = root;
    indexd->rootIa = rootIa;
    indexd->rootIb = rootIb;
    indexd->lbsize = lbsize;
    indexd->node_bit = node_bit;
    indexd->obj_bit = obj_bit;
    indexd->noded = noded;
    indexd->objectd = objectd;

    return indexd;
}
