#include	<stdio.h>
#include        <math.h>
#include	"indexData.h"

extern int     *leafid;
extern int  allbit, allbit_c;

int index_write(indexd, filename)
struct  IndexData *indexd;
char	*filename;
{
    struct  NodeData **noded;
    struct  ObjectData  **objectd;

    int     fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel, root;
    unsigned int *node_bit, *obj_bit;
    double *rootIa, *rootIb;
    int *lbsize;

    FILE       *fp;
    int         i, j, k, n, maxn;

    fmax = indexd->fmax;
    nmax = indexd->nmax;
    irn = indexd->irn;
    tnnode = indexd->tnnode;
    tnobj = indexd->tnobj;
    maxnode = indexd->maxnode;
    minnode = indexd->minnode;
    maxnode_l = indexd->maxnode_l;
    minnode_l = indexd->minnode_l;
    maxlevel = indexd->maxlevel;
    root = indexd->root;
    rootIa = indexd->rootIa;
    rootIb = indexd->rootIb;
    lbsize = indexd->lbsize;
    node_bit = indexd->node_bit;
    obj_bit = indexd->obj_bit;
    noded = indexd->noded;
    objectd = indexd->objectd;

    fp = fopen(filename,"wb+");
    if (fp == NULL){
        fprintf(stderr,"index_write() error\n");
	return 1;
    }

   /* line 1 */
    fprintf(fp,"%d %d %d %d %d %d %d %d %d %d %d ",fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel,root);
    fprintf(fp,"\n");

    n=fwrite(rootIa, sizeof(double), irn, fp);
    n=fwrite(rootIb, sizeof(double), irn, fp);
    n=fwrite(lbsize, sizeof(int), irn, fp);

   /* line 2 node_bit */
    k = (int)(nmax / (sizeof(unsigned int)*8)) + 1;
    n=fwrite(node_bit, sizeof(int), k, fp);

   /* line 3 obj_bit */
    k = (int)(fmax / (sizeof(unsigned int)*8)) + 1;
    n=fwrite(obj_bit, sizeof(int), k, fp);

   /*
    * write node data
    */

   /* line 4 num_child */
    for ( i = 0; i < nmax ; i++)
        n=fwrite(&(noded[i]->num_child), sizeof(int), 1, fp);

   /* line 5 child-id */
    for ( i = 0; i < nmax ; i++)
        for (j=0 ; j<noded[i]->num_child ; j++)
            n=fwrite(&(noded[i]->cd[j].id), sizeof(int), 1, fp);

   /* line 6 cent, Ia and Ib */
    for ( i = 0; i < nmax ; i++){
        for (j=0 ; j<noded[i]->num_child ; j++)
            n=fwrite(noded[i]->cd[j].cent, sizeof(double), irn, fp);
        if (leafid[i] != ON){
            for (j=0 ; j<noded[i]->num_child ; j++)
                n=fwrite(noded[i]->cd[j].Ia, sizeof(double), irn, fp);
            for (j=0 ; j<noded[i]->num_child ; j++)
                n=fwrite(noded[i]->cd[j].Ib, sizeof(double), irn, fp);
        }
    }

   /* line 9 omega */
    for ( i = 0; i < nmax ; i++)
        for (j=0 ; j<noded[i]->num_child ; j++)
            n=fwrite(&(noded[i]->cd[j].omega), sizeof(int), 1, fp);

    if (maxnode > maxnode_l)
        maxn = maxnode;
    else
        maxn = maxnode_l;

   /* line 11 loc_bit */
    for ( i = 0; i < nmax ; i++)
        n=fwrite(noded[i]->loc_bit, sizeof(int), allbit*maxn, fp);

   /* line 12 lbit_cent */
    for ( i = 0; i < nmax ; i++)
        n=fwrite(noded[i]->lbit_cent, sizeof(int), allbit_c*maxn, fp);

   /*
    * write data objects
    */

   /* line 13 obj_name */
    for ( i = 0; i < fmax; i++)
        n=fwrite(objectd[i]->obj_name, 1, 20, fp);

    fclose(fp);
    return 0;
}
