#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

#define    DBG         0
#define    DBG2        0
#define    DBG3        0
#define    DBG4        0
#define    DBG5        0

/*
 * DBG5=1 : no reinsert
 */

extern void                chosubtr();
extern int                 changec();
extern void                adjusttree();
extern int                 reppnum();
extern unsigned int       *bit_set();
extern int                 bit_chk();
extern double              euclid_m();
extern void                udmap();

void   ins_m();
void   reins_m();
void   split_m();
int    chospax();
void   chospix();
int    nodestack();
void   setstdist();
int    grnewnode();
int    setchild();
double calc_var();
void   shiftpath();
void   setpath();
void   setnode();
#if RI_WJ
#else
void   shiftri();
#endif

#if DACCESS
void   renewmap();
void   renew1l();
extern struct AccData    *accd;
extern int    *leafid;
#endif

extern int     nmax, tnnode, maxnode, minnode, maxnode_l, minnode_l, irn, maxlevel, root;
extern struct  NodeData **noded;
extern struct  ObjectData **objectd;

extern unsigned int *node_bit;
extern int allbit, allbit_c;

extern int *ri_flag;
extern int *ch_flag;

extern struct PathData *path;

extern struct StackData **stackd;
extern int maxst;

extern int     *setbufi();
extern double  *setbuff();

extern double *tmp_cent;

extern int cmode;

void ins_m(id, icodea, icodeb, icodec, omega, level)
int     id;
double *icodea;
double *icodeb;
double *icodec;
int     omega;
int     level;
{
    int i, j, m, node1, max;
    int pnid[BUF_LEVEL+1];
   /* choose subtree for insertion */
    chosubtr(pnid, level, icodec);

   /*
    * add to insert path
    */
    for (i=0 ; i<=level ; i++)
        setpath(pnid[i], i);

    node1 = pnid[level];
#if VLC
    ch_flag[node1] = ON;
#endif
    setpath(id , level+1);

    m = setchild(node1, id);
    setnode(node1, id, m, icodea, icodeb, icodec, omega);
#if DACCESS
    if (level == maxlevel)
        renew1l(node1, LEAF);
    else
        renew1l(node1, NON_LEAF);
#endif

#if DBG
printf("ins_m cp2 cid=%d nid=%d num_child=%d\n",id,node1,noded[node1]->num_child);
#endif
    for (i=level ; i>=0 ; i--){
        node1 = pnid[i];
        if (i==maxlevel)
            max = maxnode_l;
        else
            max = maxnode;
       /*
        * overflow treatment
        */
        if (noded[node1]->num_child > max){
            m = maxlevel;

#if DBG5
#else

#if RI_WJ
            if (ri_flag[node1] == NOT_INVOKE && i != 0){
#else
            if (ri_flag[i] == NOT_INVOKE && i != 0){
#endif

#if DBG
printf("ins_m cp3-0 reins cid=%d nid=%d level=%d/%d num_child=%d maxnode=%d\n",id,node1,i,maxlevel,noded[node1]->num_child,max);
#endif
                reins_m(pnid, i);
            }
            else{
#if DBG
printf("ins_m cp3-1 split cid=%d nid=%d level=%d/%d\n",id,node1,i,maxlevel);
#endif
#endif
                split_m(pnid, i);
#if DBG5
#else
            }
#endif
            if (maxlevel != m){
                for (j=maxlevel ; j>=0 ; j--){
                    pnid[j+1] = pnid[j];
                    pnid[0] = root;
		}
                i++;
	    }
        }
        else
            break;
    }
    adjusttree(ON);
}

/*
 * reinsert module
 */
void   reins_m(pnid, level)
int    *pnid;
int     level;
{
    int i,j,m,p,id,pid,pnum;
    int stid;

    if (level != 0)
        pid = pnid[level-1];
    id = pnid[level];
    pnum = reppnum(pid, id);

    adjusttree(OFF);

    for (i=0 ; i<=level ; i++)
        setpath(pnid[i], i);

#if DBG3
if (pnum== -1){
printf("Error : pnum in ins_m\n");
exit(1);
}
#endif
    if (level==maxlevel)
        p = (int)((double)(maxnode_l * (100-REINS_P)) / (double)100 + 0.5);
    else
        p = (int)((double)(maxnode * (100-REINS_P)) / (double)100 + 0.5);
#if RI_WJ
    ri_flag[id] = INVOKE;
#else
    ri_flag[level] = INVOKE;
#endif
    ch_flag[id] = ON;

    stid = nodestack(id);
    for (i=0 ; i<noded[id]->num_child ; i++)
        stackd[stid]->netd[i].distance = euclid_m(noded[pid]->cd[pnum].cent, noded[id]->cd[i].cent, irn);

    qsort(stackd[stid]->netd, stackd[stid]->num, sizeof(struct NetDatac), changec);
    noded[id]->num_child = p;
    for (i=0 ; i<p ; i++)
        setnode(id, stackd[stid]->netd[i].id, i, stackd[stid]->netd[i].Ia, stackd[stid]->netd[i].Ib, stackd[stid]->netd[i].cent, stackd[stid]->netd[i].omega);

#if DACCESS
    if (level == maxlevel)
        renew1l(id, LEAF);
    else
        renew1l(id, NON_LEAF);
#endif
    adjusttree(ON);

   /*
    * close reinsert
    */
    for (i=p ; i<stackd[stid]->num ; i++){
        m = maxlevel;
        ins_m(stackd[stid]->netd[i].id, stackd[stid]->netd[i].Ia, stackd[stid]->netd[i].Ib, stackd[stid]->netd[i].cent, stackd[stid]->netd[i].omega, level);
        if (maxlevel != m){
            level++;
#if DBG3
            if (maxlevel-m != 1){
                printf("reins error! difference in level is %d\n",maxlevel-m);
                exit(1);
            }
#endif
        }
    }
    stackd[stid]->use = OFF;
}

/*
 * split module
 */
void    split_m(pnid, level)
int    *pnid;
int     level;
{
    int axis,id2,id,pid;
    int i,j,k,n,m;
    int stid;
#if RI_WJ
    int gpid, omega;
    double cent[BUF_IRN], Ia[BUF_IRN], Ib[BUF_IRN], dist1, dist2;
#endif

    if (level != 0)
        pid = pnid[level-1];
    id = pnid[level];

    stid = nodestack(id);

   /* 
    * ChooseSplitAxis
    */
    axis = chospax(stid);

   /* 
    * ChooseSplitIndex
    */
    chospix(stid, axis, level);

   /*
    * assign to the first group
    */
    for (i=0 ; i<stackd[stid]->num2 ; i++)
        setnode(id, stackd[stid]->netd[i].id, i, stackd[stid]->netd[i].Ia, stackd[stid]->netd[i].Ib, stackd[stid]->netd[i].cent, stackd[stid]->netd[i].omega);
    noded[id]->num_child = stackd[stid]->num2;

   /*
    * assign to the second group
    */
    id2 = grnewnode(level);
    for (i=stackd[stid]->num2, k=0 ; i<stackd[stid]->num ; i++, k++)
        setnode(id2, stackd[stid]->netd[i].id, k, stackd[stid]->netd[i].Ia, stackd[stid]->netd[i].Ib, stackd[stid]->netd[i].cent, stackd[stid]->netd[i].omega);
    noded[id2]->num_child = stackd[stid]->num - stackd[stid]->num2;

    stackd[stid]->use = OFF;

#if DACCESS
    if (level == maxlevel)
        renewmap(id2, LEAF);
    else
        renewmap(id2, NON_LEAF);
#endif

   /*
    * set data to parent node
    */
    if (level != 0){
        m = setchild(pid, id2);
       /*
        * add to insert path
        */
        setpath(id2, level);
#if RI_WJ
        if (level > 1){
            adjusttree(OFF);
#if VLC
            ch_flag[pid] = ON;
#endif
            ch_flag[id] = ON;
            ch_flag[id2] = ON;
            for (i=0 ; i<=level ; i++)
                setpath(pnid[i], i);
            n = reppnum(pid, id);
            gpid = pnid[level-2];
            k = reppnum(gpid, pid);
            dist1 = euclid_m(noded[gpid]->cd[k].cent, noded[pid]->cd[n].cent, irn);
            dist2 = euclid_m(noded[gpid]->cd[k].cent, noded[pid]->cd[m].cent, irn);
            if (dist1 < dist2){
                noded[pid]->num_child--;
                adjusttree(ON);

                ri_flag[id2] = INVOKE;
                ins_m(id2, noded[pid]->cd[m].Ia, noded[pid]->cd[m].Ib, noded[pid]->cd[m].cent, noded[pid]->cd[m].omega, level-1);
	    }
            else{
                for (i=0 ; i<irn ; i++){
                    Ia[i] = noded[pid]->cd[n].Ia[i];
                    Ib[i] = noded[pid]->cd[n].Ib[i];
                    cent[i] = noded[pid]->cd[n].cent[i];
		}
                omega = noded[pid]->cd[n].omega;
                setnode(pid, id2, n, noded[pid]->cd[m].Ia, noded[pid]->cd[m].Ib, noded[pid]->cd[m].cent, noded[pid]->cd[m].omega);
                noded[pid]->num_child--;
                for (i=0 ; i<path->num[level] ; i++){
                    if (path->node[level][i] == id){
                        path->node[level][i] = id2;
                        break;
                    }
                }
                adjusttree(ON);

                ri_flag[id] = INVOKE;
                ins_m(id, Ia, Ib, cent, omega, level-1);
            }
	}
        else{
          /*
           * if(level == 1)
           */
#if VLC
           ch_flag[pid] = ON;
#endif
           ch_flag[id] = ON;
           ch_flag[id2] = ON;
	}
#else
#if VLC
       ch_flag[pid] = ON;
#endif
       ch_flag[id] = ON;
       ch_flag[id2] = ON;
#endif
    }
    else{
       /*
        * split root
        */
        maxlevel++;
        root = grnewnode(level);
        noded[root]->num_child = 0;
        m = setchild(root, id);
        m = setchild(root, id2);
        ch_flag[root] = ON;
        ch_flag[id] = ON;
        ch_flag[id2] = ON;
#if DACCESS
        renewmap(root, NON_LEAF);
#endif
       /*
        * add to insert path
        */
        setpath(id2, level);
        shiftpath();
#if RI_WJ
#else
        shiftri(maxlevel);
#endif
    }
}

/* 
 * ChooseSplitAxis
 */
int chospax(int stid){

    int i,axis;
    double sel_var,var;

    for (i=0 ; i<irn ; i++){
        setstdist(stid, i);
        var = calc_var(stid, 0, stackd[stid]->num);
        if (i==0 || sel_var < var){
            axis = i;
            sel_var = var;
        }
    }
    return axis;
}

/* 
 * ChooseSplitIndex
 */
void    chospix(stid, axis, level)
int     stid;
int     axis;
int     level;
{
    int i,j,m,k,e1,e2,max,min;
    double sel_var, var, tmp;

    if (level==maxlevel){
        max=maxnode_l;
        min=minnode_l;
    }
    else{
        max=maxnode;
        min=minnode;
    }
    m = max - 2 * min + 2;
    setstdist(stid, axis);
   /*
    * sort by the distance between a query point and the center point
    */
    qsort(stackd[stid]->netd, stackd[stid]->num, sizeof(struct NetDatac), changec);
    for (i=0 ; i<m ; i++){
       /*
        * calculate variance
        * 0:first group , 1:second group
        */
        e1 = 0;
        e2 = min + i;
        var = calc_var(stid, e1, e2);
        e1 = min + i;
        e2 = max + 1;
        tmp = calc_var(stid, e1, e2);
        var += tmp;
       /*
        * keep the calculated distribution
        */
        if (i==0 || sel_var > var){
            sel_var = var;
            stackd[stid]->num2 =  min + i;
#if DBG2
printf("chospix CHANGE %d sel_var=%f\n",i,sel_var);
#endif
        }
#if DBG2
else
printf("chospix NO CHANGE %d var=%f\n",i,var);
#endif
    }
}

double calc_var(stid, e1, e2)
int stid;
int e1;
int e2;
{
    int i;
    double  mean=0.0, var=0.0, sel_var, tmp;

    for (i=e1 ; i<e2 ; i++)
        mean += stackd[stid]->netd[i].distance;
    mean = mean / (double)(e2 - e1);
    for (i=e1 ; i<e2 ; i++){
        tmp = pow((stackd[stid]->netd[i].distance - mean), 2);
        var += tmp;
    }
    var = var / (double)(e2 - e1);
    return var;
}

int    nodestack(int id){

    int  i, j, stid;

    for (i=0 ; i<maxst ; i++)
	if (stackd[i]->use == OFF)
	    break;
    if (i == maxst){
        printf("Error maxst=%d\n",maxst);
        exit(1);
    }

    stid = i;
    stackd[stid]->use = ON;
    stackd[stid]->num = noded[id]->num_child;
    for (i=0 ; i<noded[id]->num_child ; i++){
        stackd[stid]->netd[i].id = noded[id]->cd[i].id;
        for (j=0 ; j<irn ; j++){
            stackd[stid]->netd[i].Ia[j] = noded[id]->cd[i].Ia[j];
            stackd[stid]->netd[i].Ib[j] = noded[id]->cd[i].Ib[j];
            stackd[stid]->netd[i].cent[j] = noded[id]->cd[i].cent[j];
        }
        stackd[stid]->netd[i].omega = noded[id]->cd[i].omega;
    }
    return stid;
}

void    setstdist(stid, axis)
int     stid;
int     axis;
{
    int  i;
    for (i=0 ; i<stackd[stid]->num ; i++)
        stackd[stid]->netd[i].distance = stackd[stid]->netd[i].cent[axis];
}

int setchild(pid, cid)
int pid;
int cid;
{
    int i,num;

    num = noded[pid]->num_child;
    noded[pid]->cd[num].id = cid;
    noded[pid]->num_child++;

    return num;
}

void setnode(pid, cid, pnum, codea, codeb, codec, omega)
int pid;
int cid;
int pnum;
double *codea;
double *codeb;
double *codec;
int omega;
{
    int i;

    noded[pid]->cd[pnum].id = cid;
    for (i=0 ; i<irn ; i++){
        noded[pid]->cd[pnum].Ia[i] = codea[i];
        noded[pid]->cd[pnum].Ib[i] = codeb[i];
        noded[pid]->cd[pnum].cent[i] = codec[i];
    }
    noded[pid]->cd[pnum].omega = omega;
}

int grnewnode(int level)
{
    int id, i, k;

    for (id=0 ; id<nmax ; id++){
        if (bit_chk(node_bit, id) == OFF)
            break;
    }
    if (id >= nmax){
        printf("Error : nmax is too small. nmax=%d\n",nmax);
        exit(1);
    }
    bit_set(node_bit, ON, id, id);

    if (cmode == CONSTRUCT){
       /* new node is a leaf */
        if (level == maxlevel){
            for (i=0 ; i<maxnode_l+1 ; i++){
                noded[id]->cd[i].cent = setbuff(noded[id]->cd[i].cent, irn);
                noded[id]->cd[i].Ia   = tmp_cent;
                noded[id]->cd[i].Ib   = tmp_cent;
	    }
            noded[id]->loc_bit = (unsigned int *)setbufi((int *)noded[id]->loc_bit, allbit*(maxnode_l+1));
            for (k=0 ; k<allbit*(maxnode_l+1) ; k++) noded[id]->loc_bit[k]=0;
            noded[id]->lbit_cent = (unsigned int *)setbufi((int *)noded[id]->lbit_cent, allbit_c*(maxnode_l+1));
            for (k=0 ; k<allbit_c*(maxnode_l+1) ; k++) noded[id]->lbit_cent[k]=0;
        }
       /* new node is not a leaf */
        else{
            for (i=0 ; i<maxnode+1 ; i++){
                noded[id]->cd[i].cent = setbuff(noded[id]->cd[i].cent, irn);
                noded[id]->cd[i].Ia   = setbuff(noded[id]->cd[i].Ia, irn);
                noded[id]->cd[i].Ib   = setbuff(noded[id]->cd[i].Ib, irn);
	    }
            noded[id]->loc_bit = (unsigned int *)setbufi((int *)noded[id]->loc_bit, allbit*(maxnode+1));
            for (k=0 ; k<allbit*(maxnode+1) ; k++) noded[id]->loc_bit[k]=0;
            noded[id]->lbit_cent = (unsigned int *)setbufi((int *)noded[id]->lbit_cent, allbit_c*(maxnode+1));
            for (k=0 ; k<allbit_c*(maxnode+1) ; k++) noded[id]->lbit_cent[k]=0;
        }
    }
    tnnode++;
    return id;
}

void   shiftpath(){
    int  i, j;

    for (i=maxlevel+1 ; i>=0 ; i--){
        for (j=0 ; j<path->num[i] ; j++){
             path->node[i+1][j] = path->node[i][j];
	}
    }

    for (i=maxlevel+1 ; i>=0 ; i--){
        path->num[i+1] = path->num[i];
    }

    path->node[0][0] = root;
    path->num[0] = 1;
}

#if RI_WJ
#else
void shiftri(int m){
    int  i;

    for (i=m ; i>=0 ; i-- )
        ri_flag[i+1] = ri_flag[i];
    ri_flag[0] = NOT_INVOKE;
}
#endif

void setpath(id, level)
int    id;
int    level;
{
    int i,m,flag=OFF;

    for (i=0 ; i<path->num[level] ; i++){
        if (path->node[level][i] == id){
            flag = ON;
            break;
	}
    }
    if (flag == OFF){
        m = path->num[level];
        path->node[level][m] = id;
        path->num[level]++;
    }
}

#if DACCESS
void   renewmap(int id, int flag){

    int i, j, k, p, volf, cnt;

    int  maxpage, *mapsizeX, mapsizeY, *page, **map, partitionY;
    maxpage = accd->maxpage;
    mapsizeX = accd->mapsizeX;
    mapsizeY = accd->mapsizeY;
    page = accd->page;
    map = accd->map;
    partitionY = accd->partitionY;

   /*
    * VIRTUAL part
    */
    if (flag == NON_LEAF)
        volf = accd->vol_frac_v_non;
    else
        volf = accd->vol_frac_v_leaf;

    p = map[partitionY-1][D_NODED];
    cnt = 1;
    for (i=partitionY-2 ; i>=0 ; i--){
        if (map[i][D_NODED]==p) cnt++;
        else break;
    }
    if (cnt >= volf){
        for(i = maxpage-1 ; i >= p+1 ; i--)
            page[i+1] = page[i];
        page[p+1] = ON;
    }
    partitionY++;
    leafid[id] = flag;

    accd->maxpage = maxpage;
    accd->mapsizeX = mapsizeX;
    accd->mapsizeY = mapsizeY;
    accd->page = page;
    accd->map = map;
    accd->partitionY = partitionY;

    udmap();
}

void   renew1l(int id, int flag){

    int i, m, k;

    int    numpages, module_size, line;
    int  maxpage, *mapsizeX, mapsizeY, *page, **map, partitionY;

    mapsizeX = accd->mapsizeX;
    map = accd->map;
    page = accd->page;

    line = accd->partitionY + id;
#if MOVMBR
#else
    for (i=0 ; i<id ; i++)
        if (leafid[i] == NON_LEAF)
            line++;
#endif

   /*
    * REAL part
    */
#if MOVMBR
    if (flag == NON_LEAF)
        module_size = noded[id]->num_child * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE;
    else
        module_size = noded[id]->num_child * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE + noded[id]->num_child * NAME_SIZE;
#else
    if (flag == NON_LEAF)
        module_size = INT_SIZE + noded[id]->num_child * 2 * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE;
    else
        module_size = INT_SIZE + noded[id]->num_child * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE + noded[id]->num_child * NAME_SIZE;
#endif

    numpages = (int)ceil(module_size/(double)PAGESIZE);
    mapsizeX[line] = D_NODED+numpages;

#if MOVMBR
#else
    if (flag == NON_LEAF){
        module_size = noded[id]->num_child * irn * 2 * FLOAT_SIZE;
        numpages = (int)ceil(module_size/(double)PAGESIZE);
        mapsizeX[line+1] = D_NODED+numpages;
    }
#endif
}
#endif
