/* Program name --- insert.c
 *       written by Sakurai   1998.5.19
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        <stdlib.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

#define         MEM_SIZE         900
#define         LOG(a,b)         (log(b)/log(a))

#define         DBG           0
#define         DBG2          0
/* write mode (index) */
#define         MODE1         1
/* write mode (map) */
#define         MODE2         1

extern void                vdb_read();
extern int                 index_write();
extern struct  IndexData *index_read();
extern unsigned int       *bit_set();
extern void                ins_m();
extern int                 bit_chk();
extern void                checkleaf();
extern void                scanleaf();

/* DACCESS mode */
extern struct AccData    *map_read();
extern void                udmap();
extern struct AccData    *daccess();
/* MODE2 */
extern void   map_write();
/* MODE2 */
/* DACCESS mode */

void     setinfo1();
int     *setbufi();
double   *setbuff();
void     error(char *);

int      rest_mem;

int      max_int;
int      bintcnt;
int      bintcnt2;
int    **buf_int;

int      max_double;
int      bdoublecnt;
int      bdoublecnt2;
double **buf_double;

struct  IndexData *indexd;
struct  NodeData **noded;
struct  ObjectData  **objectd;

int     fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel, root;

double *rootIa, *rootIb;
int    *lbsize,nlb;
int     allbit, allbit_c;

unsigned int *node_bit, *obj_bit;
int  *ri_flag;
int  *ch_flag;

struct PathData buf_path[1];
struct PathData *path=buf_path;

struct StackData **stackd;
struct StackData *buf_stack;
struct NetDatac *buf_netc;
int maxst;

struct  NodeData *buf_node;
struct  ChildData *buf_cd;
struct  ObjectData  *buf_obj;

int     *leafid;

int     num_ins;
int    *ins_id;
int     ins_cnt;

/* DACCESS mode */
struct  AccData *accd;
int  ins_level, t_level=0;
/* DACCESS mode */

double *tmp_cent;

int add_nmax;
int cmode=INSERT;

main(argc,argv)
int	argc;
char	*argv[];
{

    char    index_file[128];
    char    ins_list[128];
    char    read_buf[5000];
    FILE    *fp;
    int     i, j, k, m, p, u, id, rmax, add_fmax, flag, maxn, num_leaf, num_nleaf;

    unsigned int *tmpbit;

#if DACCESS
    int    *mapsizeX,mapsizeY,**map,*acc,*page;
    int     vol_frac_v_leaf, vol_frac_v_non, vol_r_non, vol_r_non2, vol_r_leaf;
    FILE   *fp_acc;
    char    map_file[128];
    char    acc_file[128];
    int     maxpage, totalpage=0, minrecord[6], maxrecord[6];
    double  avepage;
    int    *buf_mapsizeX,*buf_map,*buf_page;
    int     module_size;
    int     allbyte2;
#endif

#if MODE1
    char    index_file_bak[128];
#endif
#if MODE2
    char    map_file_bak[128];
#endif

#if DACCESS
    if (argc != 5 ) error(argv[0]);
#else
    if (argc != 3 ) error(argv[0]);
#endif

    strcpy(ins_list,argv[1]);
    strcpy(index_file,argv[2]);

#if DACCESS
    strcpy(map_file,argv[3]);
    strcpy(acc_file,argv[4]);
#endif

   /*
    * read ins_list
    */

    if ( ( fp = fopen ( ins_list , "r" ) ) == NULL ){
        printf( "  %s can not open\n" , ins_list);
    	exit(1);
    }
    rmax = 0;
    while (fgets(read_buf,5000,fp) != NULL ) rmax++;

    rewind(fp);

    /*
     * read index file
     */
    num_leaf=rmax;
    num_nleaf=rmax/2;
    add_nmax = num_leaf + num_nleaf;
    indexd = index_read(index_file);

    fmax = indexd->fmax;
    nmax = indexd->nmax;
    irn = indexd->irn;
    tnnode = indexd->tnnode;
    tnobj = indexd->tnobj;
    maxnode = indexd->maxnode;
    minnode = indexd->minnode;
    maxnode_l = indexd->maxnode_l;
    minnode_l = indexd->minnode_l;
    maxlevel = indexd->maxlevel;
    root = indexd->root;
    rootIa = indexd->rootIa;
    rootIb = indexd->rootIb;
    lbsize = indexd->lbsize;
    node_bit = indexd->node_bit;
    obj_bit = indexd->obj_bit;
    noded = indexd->noded;
    objectd = indexd->objectd;

    nlb = lbsize[0];

   /*
    * fmax & nmax
    */
    tnobj = tnobj + rmax;
    if (fmax < tnobj) {
        add_fmax = tnobj - fmax;
        fmax = tnobj;
    }
    nmax += add_nmax;
    leafid = (int *)malloc(sizeof(int) * nmax);
    checkleaf(leafid);

    if (maxnode > maxnode_l)
        maxn = maxnode;
    else
        maxn = maxnode_l;

   /*
    * memory allocation (double)
    */
    rest_mem = MEM_SIZE*1000*1000;
    max_double = irn * add_fmax + irn;
   /* stackd */
    maxst = (int)(nmax * 0.05) + 100;
    max_double += maxst * (maxn+1) * 3;

    if (rest_mem - max_double*8 < 0){
        printf("Error: Can't allocate memory max_double=%d\n",max_double);
        exit(1);
    }
    else
        rest_mem -= max_double*8;
    bdoublecnt = bdoublecnt2 = 0;
    buf_double = (double **)malloc(sizeof(double *));
    buf_double[0] = (double *)malloc(sizeof(double) * max_double);
    if (buf_double == NULL || buf_double[0] == NULL){
        printf("Allocation error : buf_double\n");
        exit(1);
      }

   /*
    * memory allocation (int)
    */
   /* ri_flag(RI_WJ mode) */
    max_int = nmax;
   /* ch_flag */
    max_int += nmax;
   /* obj_bit */
    max_int += (int)(fmax / (sizeof(unsigned int)*8)) + 1;
   /* node_bit */
    max_int += (int)(nmax / (sizeof(unsigned int)*8)) + 1;
   /* ins_id */
    max_int += rmax;    

#if DACCESS
    accd = map_read(map_file);
    maxpage = accd->maxpage;
    mapsizeY = accd->mapsizeY;
    acc = accd->acc;
    vol_r_non = accd->vol_r_non;
#if MOVMBR
#else
    vol_r_non2 = accd->vol_r_non2;
#endif
    vol_r_leaf = accd->vol_r_leaf;
    vol_frac_v_leaf = accd->vol_frac_v_leaf;
    vol_frac_v_non = accd->vol_frac_v_non;

#if MOVMBR
    if (vol_r_non > vol_r_leaf)
        k = vol_r_non;
    else
        k = vol_r_leaf;
#else
    if (vol_r_non > vol_r_leaf && vol_r_non > vol_r_non2){
        k = vol_r_non;
    }
    else{
        if (vol_r_non2 > vol_r_leaf)
            k = vol_r_non2;
        else
            k = vol_r_leaf;
    }
#endif
    max_int += (nmax+1)*3 + (nmax+1)*(k+1) + (nmax+1)*(D_NODED+k)*3;
#endif

    if (rest_mem - max_int*4 < 0){
        printf("Error: Can't allocate memory max_int=%d\n",max_int);
        exit(1);
    }
    else
        rest_mem -= max_int*4;
    bintcnt = bintcnt2 = 0;
    buf_int = (int **)malloc(sizeof(int *));
    buf_int[0] = (int *)malloc(sizeof(int) * max_int);
    if (buf_int == NULL || buf_int[0] == NULL){
        printf("Allocation error : buf_int\n");
        exit(1);
      }

   /*
    * recalculate obj_bit and node_bit
    */
    k = (int)(fmax / (sizeof(unsigned int)*8)) + 1;
    tmpbit = (unsigned int *)setbufi((int *)tmpbit, k);
    m = (int)((fmax-add_fmax) / (sizeof(unsigned int)*8)) + 1;
    for (i=0 ; i<m ; i++)
        tmpbit[i] = obj_bit[i];
    for (i=m ; i<k ; i++)
        tmpbit[i] = 0;
    obj_bit = (unsigned int *)setbufi((int *)obj_bit, k);
    for (i=0 ; i<k ; i++) 
        obj_bit[i] = tmpbit[i];

    k = (int)(nmax / (sizeof(unsigned int)*8)) + 1;
    m = (int)((nmax-add_nmax) / (sizeof(unsigned int)*8)) + 1;
    for (i=0 ; i<m ; i++)
        tmpbit[i] = node_bit[i];
    for (i=m ; i<k ; i++)
        tmpbit[i] = 0;
    node_bit = (unsigned int *)setbufi((int *)node_bit, k);
    for (i=0 ; i<k ; i++) 
        node_bit[i] = tmpbit[i];

   /*
    * set objectd
    */

    objectd = (struct ObjectData **)realloc(objectd, sizeof(struct ObjectData *) * (fmax));
    buf_obj = (struct ObjectData *)malloc(sizeof(struct ObjectData) * (add_fmax));
    if (objectd == NULL || buf_obj == NULL){
        printf("Allocation error : objectd\n");
        exit(1);
      }

    k = fmax - add_fmax;
    for (i=0 ; i<add_fmax ; i++){
        objectd[k+i] = buf_obj + i;
        objectd[k+i]->obj_code = setbuff(objectd[k+i]->obj_code, irn);
    }

    ins_id = setbufi(ins_id, rmax);
    p = 0;
    for (i=0 ; i<fmax ; i++){
        if (bit_chk(obj_bit, i)==OFF){
            obj_bit = bit_set(obj_bit, ON, i, i);
            ins_id[p] = i;
            p++;
        }
        if (p==rmax) break;
    }

    i=0;
    while (fgets(read_buf,5000,fp) != NULL ) {
        m = ins_id[i];
        vdb_read( read_buf, objectd[m]->obj_name, objectd[m]->obj_code, irn);
        i++;
    }
    fclose(fp);

   /*
    * set noded
    */
    tmp_cent = setbuff(tmp_cent, irn);
    for (i=0 ; i<irn ; i++)
        tmp_cent[i] = 0;

    for (i=0 ; i<nmax ; i++)
        if (bit_chk(node_bit, i)==OFF)
            noded[i]->num_child = 0;

   /*
    * malloc stackd
    */
    stackd = (struct StackData **)malloc(sizeof(struct StackData *) * maxst);
    buf_stack = (struct StackData *)malloc(sizeof(struct StackData) * maxst);
    buf_netc = (struct NetDatac *)malloc(sizeof(struct NetDatac) * maxst * (maxn+1));
    for (i=0 ; i<maxst ; i++) {
        stackd[i] = buf_stack + i;
        stackd[i]->use = 0;
        stackd[i]->netd = buf_netc + (maxn+1)*i;
        for (j=0 ; j<maxn+1 ; j++){
            stackd[i]->netd[j].cent = setbuff(stackd[i]->netd[j].cent, irn);
            stackd[i]->netd[j].Ia = setbuff(stackd[i]->netd[j].Ia, irn);
            stackd[i]->netd[j].Ib = setbuff(stackd[i]->netd[j].Ib, irn);
        }
    }

   /*
    * initialize
    */

#if DACCESS
#if MOVMBR
    m = (nmax+1) * 2;
#else
    m = (nmax+1) * 3;
#endif
    for (i=0 ; i<mapsizeY ; i++)
        if (accd->map[i][0] == NODED && accd->map[i][D_NODED-1] == REAL)
            break;
    accd->partitionY = i;

#if DBG
printf("partitionY=%d vol=%d %d %d %d %d\n",accd->partitionY,accd->vol_r_leaf,accd->vol_r_non, accd->vol_r_non2, accd->vol_frac_v_leaf,accd->vol_frac_v_non);
#endif
    buf_mapsizeX = setbufi(buf_mapsizeX, m);
    for (i=0 ; i<mapsizeY ; i++)
        buf_mapsizeX[i] = accd->mapsizeX[i];
    mapsizeX = buf_mapsizeX;
    accd->mapsizeX = mapsizeX;

    accd->map = (int **)realloc(accd->map, sizeof(int *) * m);
    if (accd->map == NULL){
        printf("Allocation error : map\n");
        exit(1);
      }
#if MOVMBR
    if (accd->vol_r_non > accd->vol_r_leaf)
        k = accd->vol_r_non;
    else
        k = accd->vol_r_leaf;
#else
    if (accd->vol_r_non > accd->vol_r_leaf && accd->vol_r_non > accd->vol_r_non2){
        k = accd->vol_r_non;
    }
    else{
        if (accd->vol_r_non2 > accd->vol_r_leaf)
            k = accd->vol_r_non2;
        else
            k = accd->vol_r_leaf;
    }
#endif
    for (i=mapsizeY ; i<m ; i++)
        accd->map[i] = setbufi(accd->map[i], D_NODED+k);

    buf_page = setbufi(buf_page, (nmax+1)*(k+1));

    page = buf_page;
    accd->page = buf_page;

    udmap();

    for (i=0 ; i<3 ; i++){
        minrecord[i] = m;
        maxrecord[i] = 0;
    }
#endif

   /* ri_flag (RI_WJ mode) */
    ri_flag = setbufi(ri_flag, nmax);
   /* ch_flag */
    ch_flag = setbufi(ch_flag, nmax);
    setinfo1();

   /*
    * initialize insert path
    */
    for (i=0 ; i<BUF_LEVEL ; i++)
        path->num[i] = 0;

   /*
    * insert data
    */

    system("/bin/date");

    for ( ins_cnt=0 ; ins_cnt<rmax ; ins_cnt++ ) {

#if DACCESS
        for (i=0 ; i<maxpage ; i++)
            accd->page[i] = OFF;
        ins_level=0;
#endif

#if DACCESS
/*
        accd->acc[0] = ADD;
        accd = daccess(accd);
*/
#endif

#if RI_WJ
        for (i=0 ; i<nmax ; i++)
#else
        for (i=0 ; i<=maxlevel+2 ; i++)
#endif
            ri_flag[i] = NOT_INVOKE;
        for (i=0 ; i<nmax ; i++)
            ch_flag[i] = OFF;

        id = ins_id[ins_cnt];
        ins_m(id, tmp_cent, tmp_cent, objectd[id]->obj_code, 1, maxlevel);

#if DACCESS
       /*
        * set the number of pages
        */
printf("ins_cnt=%d page num=",ins_cnt);
        maxpage = accd->maxpage;
        mapsizeX = accd->mapsizeX;
        mapsizeY = accd->mapsizeY;
        page = accd->page;
        map = accd->map;
        acc = accd->acc;
        m = 0;
        for (i=0 ; i<maxpage ; i++){
            if (page[i] == ON){

printf("%d ",i);

                m++;
            }
        }
printf("total=%d\n",m);

#if DBG
printf("id=%d level=%d page=%d\n",ins_cnt,ins_level,m);
#endif

        totalpage += m;
        t_level += ins_level;

        for (i=0 ; i<3 ; i++){
            if (m >= maxrecord[i]){
                for (j=2 ; j>i ; j--){
                    maxrecord[j] = maxrecord[j-1];
                    maxrecord[3+j] = maxrecord[3+j-1];
                }
                maxrecord[i] = m;
                maxrecord[3+i] = ins_cnt;
                break;
            }
        }

        for (i=0 ; i<3 ; i++){
            if (m <= minrecord[i]){
                for (j=2 ; j>i ; j--){
                    minrecord[j] = minrecord[j-1];
                    minrecord[3+j] = minrecord[3+j-1];
                }
                minrecord[i] = m;
                minrecord[3+i] = ins_cnt;
                break;
            }
        }
#endif
    }

    system("/bin/date");

   /*
    * set nmax & tnnode
    */

    for (i=nmax-1 ; i>=0 ; i--)
        if (bit_chk(node_bit, i) == ON)
            break;
    nmax = i+1;

    tnnode = 0;    
    for (i=0 ; i<nmax ; i++)
        if (bit_chk(node_bit, i) == ON)
            tnnode++;

#if DBG2
    scanleaf();
#endif

   /*
    * write index data
    */
    setinfo1();

#if MODE1
    sprintf(index_file_bak,"%s.bak",index_file);
    index_write(indexd,index_file_bak);
#endif

#if DACCESS
    if ( ( fp_acc = fopen ( acc_file , "w" ) ) == NULL ){
        printf( "  %s can not open\n" , acc_file);
        exit(1);
    }

    avepage = (double)totalpage / (double)rmax;
    fprintf(fp_acc,"total=%d average=%f rmax=%d\n",totalpage,avepage,rmax);

    if (3 > rmax) j=rmax;
    else j=3;

    fprintf(fp_acc,"max page\n");
    for (i=0 ; i<j ; i++){
        k = maxrecord[i+3];
        fprintf(fp_acc,"%d page=%d  %s\n",i,maxrecord[i],objectd[ins_id[k]]->obj_name);
    }

    fprintf(fp_acc,"min page\n");
    for (i=0 ; i<j ; i++){
        k = minrecord[i+3];
        fprintf(fp_acc,"%d page=%d  %s\n",i,minrecord[i],objectd[ins_id[k]]->obj_name);
    }

    fprintf(fp_acc,"average level=%f\n",(double)t_level/(double)rmax);

    fclose(fp_acc);

#if MODE2
    sprintf(map_file_bak,"%s.bak",map_file);
    map_write(accd, map_file_bak);
#endif
#endif

    free(buf_int);
    free(buf_double);
}

void setinfo1(){

    indexd->fmax = fmax;
    indexd->nmax = nmax;
    indexd->irn = irn;
    indexd->tnnode = tnnode;
    indexd->tnobj = tnobj;
    indexd->maxnode = maxnode;
    indexd->minnode = minnode;
    indexd->maxnode_l = maxnode_l;
    indexd->minnode_l = minnode_l;
    indexd->maxlevel = maxlevel;
    indexd->root = root;
    indexd->rootIa = rootIa;
    indexd->rootIb = rootIb;
    indexd->lbsize = lbsize;
    indexd->node_bit = node_bit;
    indexd->obj_bit = obj_bit;
    indexd->noded = noded;
    indexd->objectd = objectd;
}

int *setbufi(data, size)
int   *data;
int    size;
{
    int    i;

    if (bintcnt + size > max_int) {
        bintcnt2++;
        bintcnt = 0;
        max_int = (int)(max_int * 1.5);
        if (size > max_int) max_int = size;
        buf_int = (int **)realloc(buf_int,sizeof(int *) * (bintcnt2+1)
);
        for (i=0 ; i<10 ; i++) {
            buf_int[bintcnt2] = (int *)malloc(sizeof(int) * max_int);
            if (buf_int[bintcnt2] == NULL) {
                printf("Error: Can't allocate memory buf_int[%d]\n",bintcnt2);
                max_int = (int)(max_int * 0.9);
                if ( i > 8 ) exit(1);
            }
            else break;
        }
    }

    data = buf_int[bintcnt2] + bintcnt;
    bintcnt += size;
    return data;
}

double *setbuff(data, size)
double  *data;
int      size;
{
    int    i;

    if (bdoublecnt + size > max_double) {
        bdoublecnt2++;
        bdoublecnt = 0;
        max_double = (int)(max_double * 1.5);
        if (size > max_double) max_double = size;
        buf_double = (double **)realloc(buf_double,sizeof(double *) * (bdoublecnt2+1));
        for (i=0 ; i<10 ; i++) {
            buf_double[bdoublecnt2] = (double *)malloc(sizeof(double) * max_double);
            if (buf_double[bdoublecnt2] == NULL) {
                printf("Error: Can't allocate memory buf_double[%d]\n",bdoublecnt2);
                max_double = (int)(max_double * 0.9);
                if ( i > 8 ) exit(1);
            }
            else break;
        }
    }

    data = buf_double[bdoublecnt2] + bdoublecnt;
    bdoublecnt += size;
    return data;
}

void error(char *toolname){
#if DACCESS
        fprintf(stderr,"Usage : %s  insert_datasets  indexfile  mapfile  accfile\n",toolname);
#else
        fprintf(stderr,"Usage : %s  insert_datasets  indexfile\n",toolname);
#endif
        exit(1);
}
