#include        <stdio.h>
#include        "indexData.h"
#include        "brpData.h"

#define         DBG           1
#define         DBG2          1
#define         ERRORC        1

extern int adjustrec();
extern void    getvarea_v();
extern void    getlb_v();
extern double  euclid_m();
extern double verleng();
#if VLC
extern int     f_lengcode();
#endif

extern double *rootIa, *rootIb;
extern int   allbit, allbit_c;

extern struct NodeData **noded;
extern struct ObjectData **objectd;
extern int    maxlevel, tnobj, tnnode, root, irn;

extern int  nlb;
extern int  maxnode, maxnode_l;

void scantree();

#if DBG2
int cnt=0,cntl=0;
#endif

int tt=0;

#if ERRORC
double  *vedge, *redge, lvedge;
int     *numnodes;
double  errratio;
double  buferrord[BUF_LEVEL*2];
int  buferrori[BUF_LEVEL];
#endif

unsigned int  buf_bit2[BUF_NLB*BUF_IRN*BUF_NODE];
unsigned int *tmp_bit2=buf_bit2;

void scanleaf(){

    int i,j;

    double codea[BUF_IRN],codeb[BUF_IRN];

#if ERRORC
    numnodes = buferrori;
    vedge = buferrord;
    redge = buferrord + BUF_LEVEL;
    errratio=0;
    for (i=0 ; i<=maxlevel ; i++){
        vedge[i] = 0;
        redge[i] = 0;
        numnodes[i] = 0;
    }
    lvedge=0;
#endif

    for (i=0 ; i<irn ; i++){
        codea[i] = rootIa[i];
        codeb[i] = rootIb[i];
    }
    scantree(0, root, codea, codeb);

printf("tt=%d\n",tt);

#if DBG
j = 0;
for (i=0 ; i<noded[root]->num_child ; i++)
 j += noded[root]->cd[i].omega;
if (tnobj != j)
printf("Error : cp1-3 scanleaf root total=%d tnobj=%d\n",j,tnobj);
#endif

#if DBG2
    printf("scantree : number of nodes is %d (number of leaves is %d)\n",cnt+1,cntl);
#endif
}

void scantree(level, id, pcodea, pcodeb)
int  level;
int  id;
double *pcodea;
double *pcodeb;
{
    int    i,j,m,num;

#if DBG
    double dist, dist2, tmp;
#endif

    double ccodea[BUF_IRN], ccodeb[BUF_IRN];
    int  tleng, tleng_t;

#if ERRORC
    double  tmpe, tmpe2;
#endif

#if VLC
    int  lengc[BUF_IRN];

    if (level == maxlevel)
        tleng_t = (int)(nlb * irn * maxnode_l / (double)noded[id]->num_child);
    else
        tleng_t = (int)(nlb * irn * maxnode / (double)noded[id]->num_child);
    tleng = f_lengcode(lengc, pcodea, pcodeb, tleng_t);

if (level == maxlevel)
 tt += tleng;
printf("id=%d num_child=%d total=%d (%d/%d) ; ",id,noded[id]->num_child,tleng,tleng_t,nlb*irn);
printf("allbit=%d allbit_c=%d ; ",allbit, allbit_c);
for (i=0 ; i<irn ; i++)
  printf("%d ",lengc[i]);
printf("\n");
#else
    tleng = nlb * irn;
#endif

    if (level == maxlevel){
       /*
        * Leaf node
        */
#if FAST
#else
        for (j=0 ; j<allbit_c*maxnode_l ; j++)
            tmp_bit2[j] = noded[id]->lbit_cent[j];
#endif
        for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
            getlb_v(noded[id]->lbit_cent, pcodea, pcodeb, noded[id]->cd[i].cent, noded[id]->cd[i].cent, tleng*i, POINT, lengc);
#else
            getlb_v(noded[id]->lbit_cent, pcodea, pcodeb, noded[id]->cd[i].cent, noded[id]->cd[i].cent, tleng*i, POINT);
#endif
        }
#if FAST
#else
        for (j=0 ; j<allbit_c*maxnode_l ; j++){
            if (noded[id]->lbit_cent[j] != tmp_bit2[j]){
                printf("Error : code cp2 in scanleaf pid=%d data(%d)=%d %d\n",id,j,noded[id]->lbit_cent[j],tmp_bit2[j]);
            }
        }
#endif

#if ERRORC
        for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->lbit_cent, tleng*i, POINT, lengc);
#else
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->lbit_cent, tleng*i, POINT);
#endif
            numnodes[level]++;
            tmpe = 0;
            for (j=0 ; j<irn ; j++)
                tmpe += ccodeb[j] - ccodea[j];
            tmpe = tmpe / (double)irn;

            lvedge += tmpe;
	}
#endif

#if DBG2
        cntl++;
#endif

#if DBG
for (i=0 ; i<noded[id]->num_child ; i++)
 if (noded[id]->cd[i].omega != 1)
  printf("Error : cp3-1-1 scanleaf id=%d\n",id);
/*
printf("id=%d num_child=%d\n",id,noded[id]->num_child);
*/
for (j=0 ; j<allbit*maxnode ; j++)
 if (noded[id]->loc_bit[j] != 0)
  printf("Error : cp3-1-4 scanleaf id=%d\n",id);

for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
  getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->lbit_cent, tleng*i, POINT, lengc);
#else
  getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->lbit_cent, tleng*i, POINT);
#endif
  for (j=0 ; j<irn ; j++)
    if (ccodea[j]-0.000001 > noded[id]->cd[i].cent[j] || noded[id]->cd[i].cent[j] > ccodeb[j]+0.000001){
      printf("scanleaf Error cp11 : id=%d num=%d dim=%d r=%f v=%f %f\n",id,i,j,noded[id]->cd[i].cent[j],ccodea[j],ccodeb[j]);
    }
}
#endif
    }
    else{
       /*
        * Non-leaf node
        */
#if DBG
for (i=0 ; i<noded[id]->num_child ; i++){
for (m=0 ; m<irn ; m++){
if (noded[id]->cd[i].cent[m] < noded[id]->cd[i].Ia[m]-0.000001 || noded[id]->cd[i].cent[m] > noded[id]->cd[i].Ib[m]+0.000001){
printf("Error : cp1-1 scanleaf id=%d irn=%d ",id,m);
printf("%f %f %f\n",noded[id]->cd[i].Ia[m], noded[id]->cd[i].cent[m], noded[id]->cd[i].Ib[m]);
}}}

for (i=0 ; i<noded[id]->num_child ; i++){
m = noded[id]->cd[i].id;
num = 0;
for (j=0 ; j<noded[m]->num_child ; j++)
num += noded[m]->cd[j].omega;
if (noded[id]->cd[i].omega != num)
printf("Error : cp2-1 scanleaf id=%d %d omega %d %d\n",id,i,noded[id]->cd[i].omega, num);
}
#endif

#if DBG
for (i=0 ; i<noded[id]->num_child ; i++){
 m = noded[id]->cd[i].id;
 num=0;
 for (j=0 ; j<noded[m]->num_child ; j++)
  num +=noded[m]->cd[j].omega;
 if (num != noded[id]->cd[i].omega)
  printf("Error : cp3-2-1 scanleaf id=%d\n",id);
}

for (i=0 ; i<noded[id]->num_child ; i++){
 m = noded[id]->cd[i].id;
 for (num=0 ; num<irn ; num++){
  dist=0.0;
  for (j=0 ; j<noded[m]->num_child ; j++)
   dist +=noded[m]->cd[j].cent[num] * (double)noded[m]->cd[j].omega;
  dist = dist / (double)noded[id]->cd[i].omega;
  if (dist > noded[id]->cd[i].cent[num] || dist < noded[id]->cd[i].cent[num])
   printf("Wanning : cp3-2-2 scanleaf id=%d cent=%f %f\n",id,dist,noded[id]->cd[i].cent[num]);
 }
}
#endif

#if DBG2
        for (i=0 ; i<noded[id]->num_child ; i++){

            if (adjustrec(id, i, noded[id]->cd[i].id, level)==ON)
                printf("Error scantree pid=%d pnum%d id%d\n",id,i,noded[id]->cd[i].id);
            else
                cnt++;
	}
#endif

#if FAST
#else
        for (num=0 ; num<allbit*maxnode ; num++)
            tmp_bit2[num] = noded[id]->loc_bit[num];
#endif
        for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
            getlb_v(noded[id]->loc_bit, pcodea, pcodeb, noded[id]->cd[i].Ia, noded[id]->cd[i].Ib, tleng*2*i, RECT, lengc);
#else
            getlb_v(noded[id]->loc_bit, pcodea, pcodeb, noded[id]->cd[i].Ia, noded[id]->cd[i].Ib, tleng*2*i, RECT);
#endif
	}
#if FAST
#else
        for (num=0 ; num<allbit*maxnode ; num++){
            if (noded[id]->loc_bit[num] != tmp_bit2[num]){
                printf("Error of code cp1 in scanleaf pid=%d data(%d)=%d %d\n",id,num,noded[id]->loc_bit[num],tmp_bit2[num]);
            }
        }
#endif

        for (i=0 ; i<noded[id]->num_child ; i++){
#if MOVMBR
            scantree(level+1, noded[id]->cd[i].id, noded[id]->cd[i].Ia, noded[id]->cd[i].Ib);
#else
#if VLC
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->loc_bit, tleng*2*i, RECT, lengc);
#else
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->loc_bit, tleng*2*i, RECT);
#endif
            scantree(level+1, noded[id]->cd[i].id, ccodea, ccodeb);
#endif
	}

#if ERRORC
        for (i=0 ; i<noded[id]->num_child ; i++){
            numnodes[level]++;

#if VLC
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->loc_bit, tleng*2*i, RECT, lengc);
#else
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->loc_bit, tleng*2*i, RECT);
#endif
            tmpe = 0;
            for (j=0 ; j<irn ; j++)
                tmpe += noded[id]->cd[i].Ib[j] - noded[id]->cd[i].Ia[j];
            tmpe = tmpe / (double)irn;
            redge[level] += tmpe;

            tmpe2 = 0;
            for (j=0 ; j<irn ; j++)
                tmpe2 += ccodeb[j] - ccodea[j];
	    tmpe2 = tmpe2/(double)irn;
            vedge[level] += tmpe2;
	}
#endif

#if DBG
for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
  getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->loc_bit, tleng*2*i, RECT, lengc);
#else
  getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[id]->loc_bit, tleng*2*i, RECT);
#endif
  for (j=0 ; j<irn ; j++)
    if (ccodea[j] > noded[id]->cd[i].Ia[j] || noded[id]->cd[i].Ib[j] > ccodeb[j]+0.000001)
      printf("scanleaf Error cp12 : id=%d num=%d dim=%d r=%f %f v=%f %f\n",id,i,j,noded[id]->cd[i].Ia[j],noded[id]->cd[i].Ib[j],ccodea[j],ccodeb[j]);
}
#endif
    }
}
