/* Program name --- searchr.c
 *       written by Sakurai   1997.7.20
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        <time.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

#define         DBG           0
#define         DBG2          0
#define         DBG3          0

extern double             euclid_m();
extern void               vdb_read();
extern struct  IndexData *index_read();
extern int                change();
extern int                change21();
extern double             verleng();
extern void               getvarea_v();
#if VLC
extern int                f_lengcode();
#endif

/* SACCESS mode */
extern struct AccData    *map_read();
extern struct AccData    *daccess();
extern struct AccData    *dac_pnon();
extern struct AccData    *dac_pleaf();
/* SACCESS mode */

void nnsearch_m();
void prunebl();
void setcido();
void setcidn();
void    error(char *) ;

void replace_br();
void setbrlist();

struct  IndexData *indexd;
struct  NodeData **noded;
struct  ObjectData **objectd;

int     fmax, nmax, irn, tnobj, tnnode, maxnode, minnode, maxnode_l, minnode_l, maxlevel, root;

double  *rootIa;
double  *rootIb;
int     *lbsize,nlb,allbit,allbit_c;

unsigned int *node_bit, *obj_bit;

struct  SortData buf_sd[2];
struct  SortData *nn=buf_sd;
struct  SortData *vnn=buf_sd+1;
struct  NetData  *buf_net;

struct  SortData2 buf_locsd[1];
struct  SortData2 *brlist=buf_locsd;
struct  NetData2  *buf_locnet;

int     num_ret;
double  **ret_code;
int     ret_cnt;

/* SACCESS mode */
struct  AccData *accd;
int    *mapsizeX,mapsizeY,**map,*acc,*page;
FILE   *fp_acc;
char    map_file[128];
char    acc_file[128];
int     maxpage, totalpage=0, minrecord[6], maxrecord[6];
double  avepage;
/* SACCESS mode */

/* NACCESS mode */
int *nleafid,*leafid,*leafidv,t_nleafid=0,t_leafid=0,t_leafidv=0;
int cnt_obj=0;

/* DISTERR mode */
double t_disterror=0, disterror;
int    distcnt;

int add_nmax=0;

main(argc,argv)
int	argc;
char	*argv[];
{

    char    index_file[128];
    char    ret_list[128];
    char    read_buf[5000];
    char  **ret_file;
    FILE    *fp;
    int     i, j, k, m, flag, rmax;
    double   tmp;

    int    *prt_buf1;
    double *prt_buf2;
    int    *buf_int, cnt_int=0, cnt_double=0;
    double *buf_double;

    clock_t timecnt;
    double  stime=0, totaltime;

#if SACCESS
    if (argc != 6 ) error(argv[0]);
#else
    if (argc != 4 ) error(argv[0]);
#endif

    strcpy(ret_list,argv[1]);
    strcpy(index_file,argv[2]);
    num_ret = atoi(argv[3]);

#if SACCESS
    strcpy(map_file,argv[4]);
    strcpy(acc_file,argv[5]);
#endif

   /*
    * read index file
    */

#if DBG
printf("%s %d\n",index_file,num_ret);
#endif

    indexd = index_read(index_file);

    fmax = indexd->fmax;
    nmax = indexd->nmax;
    irn = indexd->irn;
    tnnode = indexd->tnnode;
    tnobj = indexd->tnobj;
    maxnode = indexd->maxnode;
    minnode = indexd->minnode;
    maxnode_l = indexd->maxnode_l;
    minnode_l = indexd->minnode_l;
    maxlevel = indexd->maxlevel;
    root = indexd->root;
    rootIa = indexd->rootIa;
    rootIb = indexd->rootIb;
    lbsize = indexd->lbsize;
    node_bit = indexd->node_bit;
    obj_bit = indexd->obj_bit;
    noded = indexd->noded;
    objectd = indexd->objectd;

    nlb = lbsize[0];

   /*
    * read ret_list
    */
    if ( ( fp = fopen ( ret_list , "r" ) ) == NULL ){
        printf( "  %s can not open\n" , ret_list);
        exit(1);
    }
    rmax = 0;
    while (fgets(read_buf,5000,fp) != NULL ) rmax++;

    rewind(fp);

    ret_file = (char **)malloc(sizeof(char *) * (rmax));
    for (i = 0 ; i < rmax ; i++)
        ret_file[i] = (char *)malloc(sizeof(char) * (100));

    ret_code = (double **)malloc(sizeof(double *) * (rmax));
    buf_double = (double *)malloc(sizeof(double) * (rmax*irn + rmax*num_ret));
    for (i=0 ; i<rmax ; i++){
        ret_code[i] = buf_double + cnt_double;
        cnt_double += irn;
    }

    i=0;
    while (fgets(read_buf,5000,fp) != NULL ) {
        vdb_read( read_buf, ret_file[i], ret_code[i], irn);
        i++;
    }
    fclose(fp);

   /*
    * memory allocation
    */

    buf_net = (struct NetData *)malloc(sizeof(struct NetData) * tnobj * 2);
    if (buf_net == NULL){
        printf("Allocation error : buf_net\n");
        exit(1);
    }
    nn->netd = buf_net;
    vnn->netd = buf_net+tnobj;
   /*
    * generate active branch list
    */
    buf_locnet = (struct NetData2 *)malloc(sizeof(struct NetData2) * (tnnode+tnobj));
    if (buf_locnet == NULL){
        printf("Allocation error : buf_locnet\n");
        exit(1);
    }
    brlist->netd = buf_locnet;

#if NACCESS
    buf_int = (int *)malloc(sizeof(int) * (rmax*num_ret+nmax*3));
#else
    buf_int = (int *)malloc(sizeof(int) * (rmax*num_ret));
#endif
    prt_buf1 = buf_int + cnt_int;
    cnt_int += rmax*num_ret;
    prt_buf2 = buf_double + cnt_double;
    cnt_double += rmax*num_ret;

#if DBG
printf("cp10\n");
#endif

   /*
    * initialize
    */

#if SACCESS
    accd = map_read(map_file);
    maxpage = accd->maxpage;
    mapsizeX = accd->mapsizeX;
    mapsizeY = accd->mapsizeY;
    page = accd->page;
    map = accd->map;
    acc = accd->acc;
    for (i=0 ; i<3 ; i++){
        minrecord[i] = maxpage;
        maxrecord[i] = 0;
    }
#endif

#if NACCESS
    nleafid = buf_int + cnt_int;
    cnt_int += nmax;
    leafid = buf_int + cnt_int;
    cnt_int += nmax;
    leafidv = buf_int + cnt_int;
    cnt_int += nmax;
#endif

   /*
    * searching
    */

    system("/bin/date");

    for ( ret_cnt=0 ; ret_cnt<rmax ; ret_cnt++ ) {

        timecnt = clock();

        nn->num = 0;
        vnn->num = 0;
        brlist->num = 0;
        for (i=0 ; i<tnnode ; i++){
            brlist->netd[i].distance1 = 0.0;
            brlist->netd[i].distance2 = 0.0;
        }

#if SACCESS
        for (i=0 ; i<maxpage ; i++)
            accd->page[i] = OFF;
#if NACCESS
        for(i=0 ; i<nmax ; i++)
            nleafid[i] = leafid[i] = leafidv[i] = OFF;
#if DISTERR
        disterror = 0;
        distcnt = 0;
#endif
#endif
#endif

#if SACCESS
/*
        accd->acc[0] = ADD;
        accd = daccess(accd);
*/
        accd->acc[0] = NODED;
        accd->acc[1] = root;
        accd->acc[2] = VIRTUAL;
        accd = daccess(accd);
#endif

#if DBG3
printf("cp11 ret_cnt=%d\n",ret_cnt);
#endif

        nnsearch_m();

        stime += (double)(clock() - timecnt);

#if DBG
printf("cp20 ret_cnt=%d num_ret=%d\n",ret_cnt,num_ret);
#endif

       /*
        * set search result
        */

        for (i=0 ; i<num_ret ; i++) {
            prt_buf1[ret_cnt*num_ret+i] = nn->netd[i].id;
            prt_buf2[ret_cnt*num_ret+i] = nn->netd[i].distance;
        }

#if SACCESS
       /*
        * set the number of pages
        */
        maxpage = accd->maxpage;
        mapsizeX = accd->mapsizeX;
        mapsizeY = accd->mapsizeY;
        page = accd->page;
        map = accd->map;
        acc = accd->acc;
        m = 0;
        for (i=0 ; i<maxpage ; i++){
            if (page[i] == ON){
                m++;
#if DBG2
printf("%d ",i);
#endif
            }
        }

#if DBG2
printf("\n");
printf("oid =%d %s pages m=%d\n",ret_cnt,ret_file[ret_cnt],m);
#endif

        totalpage += m;

        for (i=0 ; i<3 ; i++){
            if (m >= maxrecord[i]){
                for (j=2 ; j>i ; j--){
                    maxrecord[j] = maxrecord[j-1];
                    maxrecord[3+j] = maxrecord[3+j-1];
                }
                maxrecord[i] = m;
                maxrecord[3+i] = ret_cnt;
                break;
            }
        }

        for (i=0 ; i<3 ; i++){
            if (m <= minrecord[i]){
                for (j=2 ; j>i ; j--){
                    minrecord[j] = minrecord[j-1];
                    minrecord[3+j] = minrecord[3+j-1];
                }
                minrecord[i] = m;
                minrecord[3+i] = ret_cnt;
                break;
            }
        }
#if NACCESS
        for (i=0 ; i<nmax ; i++)
            if (nleafid[i] == ON)
                t_nleafid++;
/*
        for (i=0 ; i<nmax ; i++)
            if (leafidv[i] == ON)
                t_leafidv++;
*/
        for (i=0 ; i<nmax ; i++)
            if (leafid[i] == ON)
                t_leafid++;
#if DISTERR
        tmp = disterror / (double)distcnt;
        t_disterror += tmp;
#endif
#endif
#endif
    }

#if SACCESS
#else
    totaltime = stime / (double)CLOCKS_PER_SEC / (double)rmax;
    printf("%.4f sec.\n",totaltime);
#endif
    system("/bin/date");

   /*
    * output search results
    */

#if RESULT
    for (i=0 ; i<rmax ; i++) {
        for (j=0 ; j<num_ret ; j++) {        
            k=prt_buf1[i*num_ret+j];
            printf("%s %d %s %f\n",ret_file[i],j,objectd[k]->obj_name,prt_buf2[i*num_ret+j]);
        }
    }
#endif

#if SACCESS
    if ( ( fp_acc = fopen ( acc_file , "w" ) ) == NULL ){
        printf( "  %s can not open\n" , acc_file);
        exit(1);
    }

    avepage = (double)totalpage / (double)rmax;
    fprintf(fp_acc,"total=%d average=%f rmax=%d\n",totalpage,avepage,rmax);

    if (3 > rmax) j=rmax;
    else j=3;

    fprintf(fp_acc,"max page\n");
    for (i=0 ; i<j ; i++){
        k = maxrecord[i+3];
        fprintf(fp_acc,"%d page=%d  %s\n",i,maxrecord[i],ret_file[k]);
    }

    fprintf(fp_acc,"min page\n");
    for (i=0 ; i<j ; i++){
        k = minrecord[i+3];
        fprintf(fp_acc,"%d page=%d  %s\n",i,minrecord[i],ret_file[k]);
    }
#if NACCESS
    tmp = (double)t_nleafid/(double)rmax;
    fprintf(fp_acc,"non-leaf=%f ",tmp);
/*
    tmp = (double)t_leafidv/(double)rmax;
    fprintf(fp_acc,"virtual leaf=%f ",tmp);
*/
    tmp = (double)t_leafid/(double)rmax;
    fprintf(fp_acc,"leaf=%f ",tmp);

    tmp = (double)cnt_obj/(double)rmax;
    fprintf(fp_acc,"; object=%f\n",tmp);

#if DISTERR
    tmp = 1 - (t_disterror/(double)rmax);
    fprintf(fp_acc,"distance error=%f\n",tmp);
#endif
#endif
    fclose(fp_acc);
#endif

    free(buf_int);
    free(buf_double);
    free(buf_net);
}

/*
 * Hjaltason and Samet
 */
void nnsearch_m(){

    int  i,j;

    brlist->num = 1;
    nn->num = 0;
    vnn->num = 0;
    brlist->netd[0].id = root;
    brlist->netd[0].level = 0;
#if MOVMBR
    setcidn(brlist->netd[0].id, brlist->netd[0].level + 1, DUMMY, DUMMY);
    replace_br();
#else
    for (i=0 ; i<irn ; i++){
        brlist->netd[0].Ia[i] = rootIa[i];
        brlist->netd[0].Ib[i] = rootIb[i];
    }
#endif

    while(brlist->num > 0){
       /*
        * --- leaf level ---
        * compute the distance to actual objects
        */
        if (brlist->netd[0].level == maxlevel+1){
            setcido(brlist->netd[0].id, brlist->netd[0].room);
           /*
            * replace the top of ABL
            */
            replace_br();
        }
       /*
        * --- non-leaf level ---
        * order, prune and visit nodes
        */
        else {
#if MOVMBR
            setcidn(brlist->netd[0].id, brlist->netd[0].level + 1, brlist->netd[0].pid, brlist->netd[0].pnum);
#else
            setcidn(brlist->netd[0].id, brlist->netd[0].level + 1, brlist->netd[0].Ia, brlist->netd[0].Ib);
#endif
           /*
            * replace the top of ABL
            */
            replace_br();
        }
        prunebl();
    }
}

void setbrlist(int p1, int p2){
    int j;

    brlist->netd[p1].id = brlist->netd[p2].id;
    brlist->netd[p1].room = brlist->netd[p2].room;
    brlist->netd[p1].level = brlist->netd[p2].level;
    brlist->netd[p1].distance1 = brlist->netd[p2].distance1;
#if MOVMBR
    brlist->netd[p1].pid = brlist->netd[p2].pid;
    brlist->netd[p1].pnum = brlist->netd[p2].pnum;
#else
    for (j=0 ; j<irn ; j++){            
        brlist->netd[p1].Ia[j] = brlist->netd[p2].Ia[j];
        brlist->netd[p1].Ib[j] = brlist->netd[p2].Ib[j];
    }
#endif
}

void replace_br(){
    int i,num;
    double dist;

    dist = brlist->netd[1].distance1;
    num = 1;
    for (i=2 ; i<brlist->num ; i++){
        if (dist > brlist->netd[i].distance1){
            dist = brlist->netd[i].distance1;
            num = i;
        }
    }

    setbrlist(0, num);
    setbrlist(num, brlist->num-1);

    brlist->num--;
}

void prunebl()
{
    int i,j,flg1=OFF,flg2=OFF;
    double dist;

   /*
    * strategy M3
    */
    if (nn->num >= num_ret){
	flg1 = ON;
        dist = nn->netd[num_ret - 1].distance;
        if (vnn->num >= num_ret){
	    flg2 = ON;
            if (dist > vnn->netd[num_ret - 1].distance)
                dist = vnn->netd[num_ret - 1].distance;
	}
    }
    else{
        if (vnn->num >= num_ret){
	    flg2 = ON;
            dist = vnn->netd[num_ret - 1].distance;
	}
    }
    if (flg1 == ON){
        j=0;
        for (i=0 ; i<brlist->num ; i++){
            if (brlist->netd[i].distance1 < dist){
                if (i != j)
                    setbrlist(j, i);
                j++;
            }
        }
        brlist->num = j;
    }
    else{
        if (flg2 == ON){
            j=0;
            for (i=0 ; i<brlist->num ; i++){
                if (brlist->netd[i].distance1 <= dist){
                    if (i != j)
                        setbrlist(j, i);
                    j++;
                }
            }
            brlist->num = j;
	}
    }
}

void setcido(int pid, int room){
    int i,m,cid;
    double dist;

#if SACCESS
    accd->acc[0] = NODED;
    accd->acc[1] = pid;
    accd->acc[2] = REAL;
    accd->acc[3] = room;
    accd = dac_pleaf(accd);
#endif

#if NACCESS
    cnt_obj++;
#endif

    cid = noded[pid]->cd[room].id;
    dist = euclid_m(ret_code[ret_cnt], noded[pid]->cd[room].cent, irn);

/*
printf("setcido pid=%d room=%d cid=%d dist=%f\n",pid,room,cid,dist);
*/

    if (nn->num >= num_ret){
        m = num_ret - 1;
        if (dist < nn->netd[m].distance){
            nn->netd[m].distance = dist;
            nn->netd[m].id = cid;
            qsort(nn->netd, nn->num, sizeof(struct NetData), change);
        }
    }
    else{
        m = nn->num;
        nn->netd[m].distance = dist;
        nn->netd[m].id = cid;
        nn->num++;
        qsort(nn->netd, nn->num, sizeof(struct NetData), change);
    }
}

#if MOVMBR
void setcidn(int pid, int level, int gid, int gnum)
#else
void setcidn(int pid, int level, double *pcodea, double *pcodeb)
#endif
{
    int i,j,m;
    double tmp1, dist;
#if DISTERR
    double tmpd, tmp2;
#endif
#if DBG3
int lbd,u;
#endif
    double buf_codea[BUF_IRN], buf_codeb[BUF_IRN];
    double *ccodea=buf_codea, *ccodeb=buf_codeb;
    int  tleng;
#if VLC
    int  lengc[BUF_IRN];
#endif

#if MOVMBR
    double *pcodea, *pcodeb;
    if (level == 1){
        pcodea = rootIa;
        pcodeb = rootIb;
    }
    else{
        pcodea = noded[gid]->cd[gnum].Ia;
        pcodeb = noded[gid]->cd[gnum].Ib;
    }
#endif

#if VLC
    if (level <= maxlevel)
        tleng = (int)(nlb * irn * maxnode / (double)noded[pid]->num_child);
    else
        tleng = (int)(nlb * irn * maxnode_l / (double)noded[pid]->num_child);
    tleng = f_lengcode(lengc, pcodea, pcodeb, tleng);
#else
    tleng = nlb * irn;
#endif

#if SACCESS
    accd->acc[0] = NODED;
    accd->acc[1] = pid;
    accd->acc[2] = VIRTUAL;
    accd = daccess(accd);
#endif

#if NACCESS
    if (level <= maxlevel)
        nleafid[pid] = ON;
    else
        leafid[pid] = ON;
#endif

    for (i=0 ; i<noded[pid]->num_child ; i++){
#if VLC
        if (level <= maxlevel)
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->loc_bit, tleng*2*i, RECT, lengc);
        else
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->lbit_cent, tleng*i, POINT, lengc);
#else
        if (level <= maxlevel)
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->loc_bit, tleng*2*i, RECT);
        else
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->lbit_cent, tleng*i, POINT);
#endif

#if DBG3
if (level <= maxlevel){
 for (j=0 ; j<irn ; j++){
  if (ccodea[j] > noded[pid]->cd[i].Ia[j])
   printf("Error in searchr cp10 : pid=%d num=%d level=%d Ia%d=%f %f\n",pid,i,level,j,ccodea[j],noded[pid]->cd[i].Ia[j]);
  if (ccodeb[j] < noded[pid]->cd[i].Ib[j])
   printf("Error in searchr cp10 : pid=%d num=%d level=%d Ib%d=%f %f\n",pid,i,level,j,ccodeb[j],noded[pid]->cd[i].Ib[j]);
 }
}
else{
 for (j=0 ; j<irn ; j++){
  if (ccodea[j] > noded[pid]->cd[i].cent[j])
   printf("Error in searchr cp10 : pid=%d num=%d level=%d Pa%d=%f %f\n",pid,i,level,j,ccodea[j],noded[pid]->cd[i].cent[j]);
  if (ccodeb[j] < noded[pid]->cd[i].cent[j])
   printf("Error in searchr cp10 : pid=%d num=%d level=%d Pb%d=%f %f\n",pid,i,level,j,ccodeb[j],noded[pid]->cd[i].cent[j]);
 }
}
#endif

        tmp1 = verleng(ccodea, ccodeb, ret_code[ret_cnt], MINDIST, irn);

#if DISTERR
        tmpd = verleng(noded[pid]->cd[i].Ia, noded[pid]->cd[i].Ib, ret_code[ret_cnt], MINDIST, irn);
        if (tmpd != 0){
            distcnt++;
            tmp2 = tmp1/tmpd;
            disterror += tmp2;
	}
#endif

        if (nn->num >= num_ret && tmp1 >= nn->netd[num_ret-1].distance)
            continue;
        if (vnn->num >= num_ret && tmp1 >= vnn->netd[num_ret-1].distance)
            continue;

        brlist->netd[brlist->num].distance1 = tmp1;

        if (level > maxlevel){
            dist = verleng(ccodea, ccodeb, ret_code[ret_cnt], MAXDIST, irn);
            if (vnn->num >= num_ret){
                m = num_ret - 1;
                if (dist < vnn->netd[m].distance){
                    vnn->netd[m].distance = dist;
/*
                    vnn->netd[m].id = cid;
*/
                    qsort(vnn->netd, vnn->num, sizeof(struct NetData), change);
                }
            }
            else{
                m = vnn->num;
                vnn->netd[m].distance = dist;
/*
                vnn->netd[m].id = cid;
*/
                vnn->num++;
                qsort(vnn->netd, vnn->num, sizeof(struct NetData), change);
            }
	}

#if MOVMBR
#else
        for (j=0 ; j<irn ; j++){
            brlist->netd[brlist->num].Ia[j] = ccodea[j];
            brlist->netd[brlist->num].Ib[j] = ccodeb[j];
        }
#endif

        if (level <= maxlevel){
            brlist->netd[brlist->num].id = noded[pid]->cd[i].id;
#if MOVMBR
            brlist->netd[brlist->num].pid = pid;
            brlist->netd[brlist->num].pnum = i;
#endif
        }
        else{
            brlist->netd[brlist->num].id = pid;
            brlist->netd[brlist->num].room = i;
	}

        brlist->netd[brlist->num].level = level;
        brlist->num++;
    }
}

void error(char *toolname){
#if SACCESS
    fprintf(stderr,"Usage : %s  query_datasets  indexfile  num_search  mapfile  accfile\n",toolname);
#else
    fprintf(stderr,"Usage : %s  query_datasets  indexfile  num_search\n",toolname);
#endif
    exit(1);
}
