/*
 * udcode : update code
 *                     20 Apr. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

#define    DBG         0
#define    DBG2        0
#define    DBG3        0

void           checklb();
#if MOVMBR
extern void    setcode();
#else
extern void    getvarea_v();
extern void    getlb_v();
void           setlb();
#if DACCESS
extern struct AccData    *daccess();
extern struct AccData    *dac_pleaf();
extern struct AccData    *dac_pnon();
extern struct AccData    *accd;
#endif
#endif
#if VLC
extern int     f_lengcode();
#endif

extern int  irn,root,maxlevel,maxnode,maxnode_l,nlb;
extern struct  NodeData **noded;
extern struct PathData *path;

extern double *rootIa, *rootIb;
extern int  allbit, allbit_c;

#if MOVMBR
void    udcode()
{

    double   buf_area[BUF_IRN*2];
    double  *pcodea=buf_area;
    double  *pcodeb=buf_area+BUF_IRN;
    int i;

    for (i=0 ; i<irn ; i++){
        pcodea[i] = rootIa[i];
        pcodeb[i] = rootIb[i];
    }

    checklb(pcodea, pcodeb, root, 0);
}

void checklb(pcodea, pcodeb, pid, level)
double *pcodea;
double *pcodeb;
int  pid;
int  level;
{
    int  i,p,cid, num, flag;

    for (p=0 ; p<path->num[level+1] ; p++){
        cid = path->node[level+1][p];
        num = path->room[level+1][p];
        if (noded[pid]->cd[num].id != cid)
            continue;

        setcode(pcodea, pcodeb, pid, num, INDIV, level);

        if (level != maxlevel)
            checklb(noded[pid]->cd[num].Ia, noded[pid]->cd[num].Ib, cid, level+1);
    }
}

#else

void    udcode(hilevel)
int hilevel;
{

    double   buf_area[BUF_IRN*2];
    double  *pcodea=buf_area;
    double  *pcodeb=buf_area+BUF_IRN;
    int i;

    for (i=0 ; i<irn ; i++){
        pcodea[i] = rootIa[i];
        pcodeb[i] = rootIb[i];
    }

    if (hilevel >= 0)
        checklb(pcodea, pcodeb, root, 0);
    else
        setlb(pcodea, pcodeb, root, 0);
}

void checklb(pcodea, pcodeb, pid, level)
double *pcodea;
double *pcodeb;
int  pid;
int  level;
{
    int  i,j,p,cid, num, flag;
    unsigned int  buf_bit[BUF_NLB*BUF_IRN*BUF_NODE*2];
    unsigned int *tmpbit=buf_bit;
    double   buf_area[BUF_IRN*2];
    double  *ccodea=buf_area;
    double  *ccodeb=buf_area+BUF_IRN;

    int  tleng;
#if VLC
    int  lengc[BUF_IRN];
#endif

    for (p=0 ; p<path->num[level+1] ; p++){
        cid = path->node[level+1][p];
        num = path->room[level+1][p];
        if (noded[pid]->cd[num].id != cid)
            continue;

       /* update leaf node */
        if (level == maxlevel)
#if VLC
            setcode(pcodea, pcodeb, pid, DUMMY, ALL, level);
#else
            setcode(pcodea, pcodeb, pid, num, INDIV, level);
#endif
       /* update non-leaf node */
        else{
#if VLC
            for (i=0 ; i<noded[pid]->num_child ; i++){
                for (j=0 ; j<allbit*maxnode ; j++)
                    tmpbit[j] = noded[pid]->loc_bit[j];
                setcode(pcodea, pcodeb, pid, i, INDIV, level);
                flag = OFF;
                for (j=0 ; j<allbit*maxnode ; j++){
                    if (tmpbit[j] != noded[pid]->loc_bit[j]){
                        flag = ON;
                        break;
		    }
    	        }
                if (flag == ON || i == num){
                   /* if 'level' is not 'maxlevel' */
                    tleng = (int)(nlb * irn * maxnode / (double)noded[pid]->num_child);
                    tleng = f_lengcode(lengc, pcodea, pcodeb, tleng);
                    getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->loc_bit, tleng*2*i, RECT, lengc);
		}
                if (flag == ON)
                    setlb(ccodea, ccodeb, noded[pid]->cd[i].id, level+1);
                else
                    if (i == num)
                        checklb(ccodea, ccodeb, noded[pid]->cd[i].id, level+1);
	    }
#else
            for (j=0 ; j<allbit*maxnode ; j++)
                tmpbit[j] = noded[pid]->loc_bit[j];
            setcode(pcodea, pcodeb, pid, num, INDIV, level);
            flag = OFF;
            for (j=0 ; j<allbit*maxnode ; j++){
                if (tmpbit[j] != noded[pid]->loc_bit[j]){
                    flag = ON;
                    break;
		}
	    }
            tleng = nlb * irn;
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->loc_bit, tleng*2*num, RECT);
            if (flag == ON)
                setlb(ccodea, ccodeb, cid, level+1);
            else
                checklb(ccodea, ccodeb, cid, level+1);
#endif
	}
    }
}

void setlb(pcodea, pcodeb, pid, level)
double *pcodea;
double *pcodeb;
int  pid;
int  level;
{
    int  i, j, cid, num;
    unsigned int  buf_bit[BUF_NLB*BUF_IRN*BUF_NODE*2];
    unsigned int *tmpbit=buf_bit;
    double   buf_area[BUF_IRN*2];
    double  *ccodea=buf_area;
    double  *ccodeb=buf_area+BUF_IRN;

    int  tleng;
#if VLC
    int  lengc[BUF_IRN];
#endif

#if DACCESS
    if (level == maxlevel){
        accd->acc[0] = NODED;
        accd->acc[1] = pid;
        accd->acc[2] = REAL;
        accd = daccess(accd);
    }
    else{
        accd->acc[0] = NODED2;
        accd->acc[1] = pid;
        accd->acc[2] = REAL;
        accd = daccess(accd);
    }
#endif

   /* update leaf node */
    if (level == maxlevel)
        setcode(pcodea, pcodeb, pid, DUMMY, ALL, level);
   /* update non-leaf node */
    else{
        setcode(pcodea, pcodeb, pid, DUMMY, ALL, level);

#if VLC
       /* if 'level' is not 'maxlevel' */
        tleng = (int)(nlb * irn * maxnode / (double)noded[pid]->num_child);
        tleng = f_lengcode(lengc, pcodea, pcodeb, tleng);
#else
        tleng = nlb * irn;
#endif

        for (num=0 ; num<noded[pid]->num_child ; num++){
            cid = noded[pid]->cd[num].id;
#if VLC
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->loc_bit, tleng*2*num, RECT, lengc);
#else
            getvarea_v(ccodea, ccodeb, pcodea, pcodeb, noded[pid]->loc_bit, tleng*2*num, RECT);
#endif
            setlb(ccodea, ccodeb, cid, level+1);
	}
    }
}

#endif
