/* Program name --- udmap.c
 *       written by Sakurai   1999.7.5
 */

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
#include        "indexData.h"
#include        "accData.h"

#define         DBG    0

int    pagecnt;
int    bytecnt;

int    setpage();

extern int    tnnode, irn;
extern struct NodeData **noded;
extern struct AccData *accd;
extern int    *leafid;

void udmap()
{
    int    i, j, k, id;
    int    tmpcnt, numpages;

    int    module_size;
    int    *mapsizeX, mapsizeY, **map;
    mapsizeX = accd->mapsizeX;
    map = accd->map;

    pagecnt = 0;
    bytecnt = 0;
   /* node data */
    mapsizeY = 0;

   /*
    * VIRTUAL tree
    */
    for (id=0 ; id<tnnode ; id++){
        if (leafid[id] == OFF)
            numpages = setpage(accd->vol_frac_v_non, VIRTUAL);
        else
            numpages = setpage(accd->vol_frac_v_leaf, VIRTUAL);

        map[mapsizeY][0] = NODED;
        map[mapsizeY][1] = id;
        map[mapsizeY][2] = VIRTUAL;
        map[mapsizeY][3] = pagecnt;
        mapsizeX[mapsizeY] = 4;
        mapsizeY++;
    }
    pagecnt++;

   /*
    * REAL tree
    */

    for (id=0 ; id<tnnode ; id++){
        tmpcnt = pagecnt;
        if (leafid[id] == OFF)
            numpages = setpage(accd->vol_r_non, REAL);
        else
            numpages = setpage(accd->vol_r_leaf, REAL);
        map[mapsizeY][0] = NODED;
        map[mapsizeY][1] = id;
        map[mapsizeY][2] = REAL;
        for (j=0 ; j<numpages ; j++)
            map[mapsizeY][j+D_NODED] = tmpcnt + j;
        if (leafid[id] == NON_LEAF){
#if MOVMBR
            module_size = noded[id]->num_child * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE;
#else
            module_size = INT_SIZE + noded[id]->num_child * 2 * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE;
#endif
            numpages = (int)(module_size/PAGESIZE + 1);
            if (module_size % PAGESIZE == 0)
                numpages--;
            mapsizeX[mapsizeY] = D_NODED+numpages;
	}
        else{
#if MOVMBR
            module_size = noded[id]->num_child * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE + noded[id]->num_child * NAME_SIZE;
#else
            module_size = INT_SIZE + noded[id]->num_child * INT_SIZE + noded[id]->num_child * irn * FLOAT_SIZE + noded[id]->num_child * NAME_SIZE;
#endif
            numpages = (int)(module_size/PAGESIZE + 1);
            if (module_size % PAGESIZE == 0)
                numpages--;
            mapsizeX[mapsizeY] = D_NODED+numpages;
        }
        mapsizeY ++;

#if MOVMBR
#else
        if (leafid[id] == NON_LEAF){
            tmpcnt = pagecnt;
            numpages = setpage(accd->vol_r_non2, REAL);
            map[mapsizeY][0] = NODED2;
            map[mapsizeY][1] = id;
            map[mapsizeY][2] = REAL;
            for (j=0 ; j<numpages ; j++)
                map[mapsizeY][j+D_NODED] = tmpcnt + j;
            module_size = noded[id]->num_child * irn * 2 * FLOAT_SIZE;
            numpages = (int)(module_size/PAGESIZE + 1);
            if (module_size % PAGESIZE == 0)
                numpages--;
            mapsizeX[mapsizeY] = D_NODED+numpages;

            mapsizeY ++;
	}
#endif
    }
    accd->maxpage = pagecnt;
    accd->mapsizeY = mapsizeY;
}

int setpage(int vol, int mode){
    int  numpages=0;

    if (mode == VIRTUAL){
        numpages = 1;
        if (vol > bytecnt)
            bytecnt++;
        else{
            bytecnt = 1;
            pagecnt++;
	}
    }
    else{
        numpages = vol;
        pagecnt += vol;
    }
    return(numpages);
}
